"use strict";

var _axios = _interopRequireDefault(require("axios"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Copyright © 2016 Kuali, Inc. - All Rights Reserved
 * You may use and modify this code under the terms of the Kuali, Inc.
 * Pre-Release License Agreement. You may not distribute it.
 *
 * You should have received a copy of the Kuali, Inc. Pre-Release License
 * Agreement with this file. If not, please write to license@kuali.co.
 */
_axios.default.interceptors.request.use(function (config) {
  if (!config.headers['Content-Type']) {
    config.headers['Content-Type'] = 'application/json';
  }

  var token = /authToken=(.+?)(;|$)/.exec(document.cookie) && /authToken=(.+?)(;|$)/.exec(document.cookie)[1];

  if (!config.headers.Authorization && token) {
    config.headers.Authorization = "Bearer ".concat(token);
  }

  config.withCredentials = true;
  return config;
}, function (error) {
  console.log(error); // eslint-disable-line no-console
});
//# sourceMappingURL=axios-intercept.js.map
