"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _querystring = _interopRequireDefault(require("querystring"));

var _api2 = _interopRequireDefault(require("./api"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DEFINITION = 'definitions';
var VERSION = 'versions';
var STEP = 'steps';

var FlowAPI =
/*#__PURE__*/
function (_api) {
  _inherits(FlowAPI, _api);

  function FlowAPI() {
    _classCallCheck(this, FlowAPI);

    return _possibleConstructorReturn(this, _getPrototypeOf(FlowAPI).apply(this, arguments));
  }

  _createClass(FlowAPI, [{
    key: "load",
    value: function () {
      var _load = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(flow) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", this._get("".concat(FlowAPI.WORKFLOW_API, "/").concat(DEFINITION, "/").concat(flow._id)));

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function load(_x) {
        return _load.apply(this, arguments);
      };
    }()
  }, {
    key: "loadMany",
    value: function () {
      var _loadMany = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(flows) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", this._post("".concat(FlowAPI.WORKFLOW_API, "/").concat(DEFINITION, "/get-many"), flows));

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function loadMany(_x2) {
        return _loadMany.apply(this, arguments);
      };
    }()
  }, {
    key: "list",
    value: function () {
      var _list = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(q) {
        var extra;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                extra = q ? "?".concat(_querystring.default.encode(q)) : '';
                return _context3.abrupt("return", this._get("".concat(FlowAPI.WORKFLOW_API, "/").concat(DEFINITION).concat(extra)));

              case 2:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function list(_x3) {
        return _list.apply(this, arguments);
      };
    }()
  }, {
    key: "create",
    value: function () {
      var _create = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(_flow, opts) {
        var flow, cfg;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                flow = (0, _lodash.isString)(_flow) ? {
                  name: _flow
                } : _flow;
                cfg = (0, _lodash.extend)({}, opts, flow);
                return _context4.abrupt("return", this._post("".concat(FlowAPI.WORKFLOW_API, "/").concat(DEFINITION, "/create"), cfg));

              case 3:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      return function create(_x4, _x5) {
        return _create.apply(this, arguments);
      };
    }()
  }, {
    key: "createSubflow",
    value: function () {
      var _createSubflow = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5(flow, opts) {
        var cfg;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                cfg = (0, _lodash.extend)({}, opts, flow);
                return _context5.abrupt("return", this._post("".concat(FlowAPI.WORKFLOW_API, "/").concat(DEFINITION, "/subflow/create"), cfg));

              case 2:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      return function createSubflow(_x6, _x7) {
        return _createSubflow.apply(this, arguments);
      };
    }()
  }, {
    key: "updateStep",
    value: function () {
      var _updateStep = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee6(workflow, step) {
        var _id, stepId;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _id = workflow._id;
                stepId = step._id;
                return _context6.abrupt("return", this._put("".concat(FlowAPI.WORKFLOW_API, "/").concat(DEFINITION, "/").concat(_id, "/").concat(STEP, "/").concat(stepId), step));

              case 3:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      return function updateStep(_x8, _x9) {
        return _updateStep.apply(this, arguments);
      };
    }()
  }, {
    key: "update",
    value: function () {
      var _update = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee7(workflow) {
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                return _context7.abrupt("return", this._post("".concat(FlowAPI.WORKFLOW_API, "/").concat(DEFINITION, "/save"), workflow));

              case 1:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      return function update(_x10) {
        return _update.apply(this, arguments);
      };
    }()
  }, {
    key: "remove",
    value: function () {
      var _remove = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee8(workflow, permanent) {
        var _id, extra;

        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _id = workflow._id;
                extra = permanent ? "?".concat(_querystring.default.encode({
                  permanent: true
                })) : '';
                return _context8.abrupt("return", this._delete("".concat(FlowAPI.WORKFLOW_API, "/").concat(DEFINITION, "/").concat(_id).concat(extra)));

              case 3:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      return function remove(_x11, _x12) {
        return _remove.apply(this, arguments);
      };
    }()
  }, {
    key: "deleteStep",
    value: function () {
      var _deleteStep = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee9(workflow, step) {
        var _id, stepId;

        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _id = workflow._id;
                stepId = step._id;
                return _context9.abrupt("return", this._delete("".concat(FlowAPI.WORKFLOW_API, "/").concat(DEFINITION, "/").concat(_id, "/").concat(STEP, "/").concat(stepId)));

              case 3:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      return function deleteStep(_x13, _x14) {
        return _deleteStep.apply(this, arguments);
      };
    }()
  }, {
    key: "listVersions",
    value: function () {
      var _listVersions = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee10(flow) {
        var query;
        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                query = _querystring.default.encode({
                  limit: 10
                });
                return _context10.abrupt("return", this._get("".concat(FlowAPI.WORKFLOW_API, "/").concat(DEFINITION, "/").concat(VERSION, "/").concat(flow.workflowId, "?").concat(query)));

              case 2:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      return function listVersions(_x15) {
        return _listVersions.apply(this, arguments);
      };
    }()
  }]);

  return FlowAPI;
}(_api2.default);

exports.default = FlowAPI;

_defineProperty(FlowAPI, "API_KEY", 'flows');

_defineProperty(FlowAPI, "WORKFLOW_API", '/cor/workflows/api/v0');
//# sourceMappingURL=flow.js.map
