"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _querystring = _interopRequireDefault(require("querystring"));

var _api2 = _interopRequireDefault(require("./api"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// TODO: build this list somewhere else/managed
var typeMap = {
  UserId: 'user'
};

var FormAPI =
/*#__PURE__*/
function (_api) {
  _inherits(FormAPI, _api);

  function FormAPI() {
    _classCallCheck(this, FormAPI);

    return _possibleConstructorReturn(this, _getPrototypeOf(FormAPI).apply(this, arguments));
  }

  _createClass(FormAPI, [{
    key: "list",
    value: function () {
      var _list = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(_filter) {
        var filter, query, response;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                filter = _filter ? (0, _lodash.isObject)(_filter) ? Object.assign({
                  limit: 20
                }, _filter) : {
                  limit: 20,
                  q: _filter
                } : {
                  limit: 20
                };
                query = _querystring.default.encode(filter);
                _context.next = 4;
                return this._get("".concat(FormAPI.FORM_API, "/form-containers?").concat(query));

              case 4:
                response = _context.sent;
                return _context.abrupt("return", (0, _lodash.map)(response, function (form) {
                  var id = form.id,
                      label = form.label;
                  return {
                    id: id,
                    label: label
                  };
                }));

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function list(_x) {
        return _list.apply(this, arguments);
      };
    }()
  }, {
    key: "getForm",
    value: function () {
      var _getForm = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(form) {
        var id;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                id = form.id;
                return _context2.abrupt("return", this._get("".concat(FormAPI.FORM_API, "/form-containers/").concat(id)));

              case 2:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function getForm(_x2) {
        return _getForm.apply(this, arguments);
      };
    }()
  }, {
    key: "getSchema",
    value: function () {
      var _getSchema = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(form) {
        var id;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                id = form.id;
                return _context3.abrupt("return", this._get("".concat(FormAPI.FORM_API, "/form-containers/").concat(id, "/forms/current/schema")));

              case 2:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function getSchema(_x3) {
        return _getSchema.apply(this, arguments);
      };
    }()
  }, {
    key: "getDocument",
    value: function () {
      var _getDocument = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(documentId) {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt("return", this._get("".concat(FormAPI.FORM_API, "/documents/").concat(documentId)));

              case 1:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      return function getDocument(_x4) {
        return _getDocument.apply(this, arguments);
      };
    }()
  }, {
    key: "load",
    value: function () {
      var _load = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5(form) {
        var id, query, response, schema;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                id = form.id;
                query = _querystring.default.encode({
                  includeJsTypes: true
                });
                _context5.next = 4;
                return this._get("".concat(FormAPI.FORM_API, "/form-containers/").concat(id, "/forms/current/schema?").concat(query));

              case 4:
                response = _context5.sent;
                schema = response.schema;
                (0, _lodash.forEach)(schema, function (field, key) {
                  var type = (0, _lodash.isObject)(field.jsType) ? typeMap[field.jsType.id] : field.jsType;
                  schema[key] = _objectSpread({}, field, {
                    type: type,
                    displayType: field.type
                  });
                });
                return _context5.abrupt("return", response);

              case 8:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      return function load(_x5) {
        return _load.apply(this, arguments);
      };
    }()
  }, {
    key: "loadMany",
    value: function () {
      var _loadMany = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee6(forms) {
        var _this = this;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                return _context6.abrupt("return", Promise.all((0, _lodash.map)(forms, function (form) {
                  return _this.load(form);
                })));

              case 1:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      return function loadMany(_x6) {
        return _loadMany.apply(this, arguments);
      };
    }()
  }]);

  return FormAPI;
}(_api2.default);

exports.default = FormAPI;

_defineProperty(FormAPI, "API_KEY", 'forms');

_defineProperty(FormAPI, "FORM_API", '/app/forms/api/v2');
//# sourceMappingURL=form.js.map
