"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _bluebird = _interopRequireDefault(require("bluebird"));

var _context5 = _interopRequireDefault(require("../data-dictionary/context"));

var _returnTypes = require("../data-dictionary/return-types");

var _ancestryUtil = _interopRequireDefault(require("../ancestry-util"));

var _extensions = require("../extensions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var i18n = {
  MISSING_DATA: 'Workflow Context expects data to have ancestry, stepId & context'
};

var WorkflowContext =
/*#__PURE__*/
function (_Context) {
  _inherits(WorkflowContext, _Context);

  _createClass(WorkflowContext, null, [{
    key: "inflate",
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(ctx, deflated, parent, scope) {
        var ancestry, context, stepId, params;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                ancestry = deflated.ancestry, context = deflated.context, stepId = deflated.stepId;
                _context.next = 3;
                return _bluebird.default.props({
                  ancestry: _ancestryUtil.default.inflate(ancestry, ctx.scope.axios),
                  context: ctx.inflate(context)
                });

              case 3:
                params = _context.sent;
                return _context.abrupt("return", _objectSpread({}, params, {
                  stepId: stepId
                }));

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function inflate(_x, _x2, _x3, _x4) {
        return _inflate.apply(this, arguments);
      };
    }()
  }]);

  function WorkflowContext(parent, returnTypes, data, ctx) {
    var _this;

    _classCallCheck(this, WorkflowContext);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(WorkflowContext).call(this, parent, returnTypes, data, ctx));
    if (!data) throw new Error(i18n.MISSING_DATA);
    var context = data.context,
        ancestry = data.ancestry,
        stepId = data.stepId;

    if (!ancestry || !stepId || !context || !(context instanceof _context5.default)) {
      throw new Error(i18n.MISSING_DATA);
    }

    _this.ancestry = ancestry;
    _this.stepId = stepId;
    _this.context = context;
    _this.name = context.name; // CAUTION: I just redefined this.data

    _this.data = context.data;
    return _this;
  }

  _createClass(WorkflowContext, [{
    key: "getChildren",
    value: function () {
      var _getChildren = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(filter) {
        var _this2 = this;

        var children;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.context.getChildren(filter);

              case 2:
                children = _context2.sent;
                children.forEach(function (child) {
                  child.parent = _this2;
                  child.returnTypes = _this2.returnTypes;
                });
                return _context2.abrupt("return", children);

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function getChildren(_x5) {
        return _getChildren.apply(this, arguments);
      };
    }()
  }, {
    key: "deflate",
    value: function deflate() {
      var valueList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var ancestry = this.ancestry,
          context = this.context,
          name = this.name,
          parent = this.parent,
          stepId = this.stepId,
          type = this.type;
      if (parent) parent.deflate(valueList);
      var deflatedCtx = this.ctx.deflate(context);
      var deflatedAnc = ancestry.deflate();
      valueList.push({
        context: deflatedCtx,
        name: name,
        ancestry: deflatedAnc,
        requiresParent: false,
        stepId: stepId,
        type: type
      });
      return valueList;
    }
  }, {
    key: "getValue",
    value: function () {
      var _getValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3() {
        var valueMap,
            context,
            parent,
            value,
            _args3 = arguments;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                valueMap = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : {};
                context = this.context, parent = this.parent;

                if (!parent) {
                  _context3.next = 5;
                  break;
                }

                _context3.next = 5;
                return parent.getValue(valueMap);

              case 5:
                _context3.next = 7;
                return (0, _extensions.getValue)(this, context, valueMap);

              case 7:
                value = _context3.sent;

                if (!value) {
                  _context3.next = 10;
                  break;
                }

                return _context3.abrupt("return", value);

              case 10:
                _context3.t0 = context.type;
                _context3.next = _context3.t0 === 'formfill' ? 13 : 14;
                break;

              case 13:
                return _context3.abrupt("return", this.getFormfillValue(context, valueMap));

              case 14:
                throw new Error("Failed to get value of unsupported type: ".concat(context.type));

              case 15:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function getValue() {
        return _getValue.apply(this, arguments);
      };
    }()
  }, {
    key: "getFormfillValue",
    value: function () {
      var _getFormfillValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(formContext, valueMap) {
        var definition, instance, instances, formId, _this$findDefinitionS, definitionStep, instanceStep, formsAPI, responses, data;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                definition = valueMap.definition, instance = valueMap.instance, instances = valueMap.instances;
                formId = formContext.data.id;
                _this$findDefinitionS = this.findDefinitionStep(formId, definition), definitionStep = _this$findDefinitionS.step;
                instanceStep = this.findInstanceStep(definitionStep._id.toString(), instance, instances);
                formsAPI = this.ctx.apis.forms;
                _context4.next = 7;
                return _bluebird.default.props({
                  container: formsAPI.getForm({
                    id: formId
                  }),
                  schema: formsAPI.getSchema({
                    id: formId
                  }),
                  document: formsAPI.getDocument(instanceStep.meta.form.id)
                });

              case 7:
                responses = _context4.sent;
                data = _objectSpread({}, responses, {
                  definitionStep: definitionStep,
                  instanceStep: instanceStep,
                  formUrl: "/app/forms/#/i/".concat(responses.container.id, "/view/").concat(responses.document.id)
                });
                valueMap.formfill = data;
                return _context4.abrupt("return", data);

              case 11:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      return function getFormfillValue(_x6, _x7) {
        return _getFormfillValue.apply(this, arguments);
      };
    }()
  }, {
    key: "findDefinitionStep",
    value: function findDefinitionStep(formId) {
      var match;
      this.ancestry.forEachStep(function (_ref) {
        var flow = _ref.flow,
            step = _ref.step;

        if (step.type === 'formfill' && (0, _lodash.last)(step.meta.form).id === formId) {
          match = {
            flow: flow,
            step: step
          };
        }
      });
      return match;
    }
  }, {
    key: "findInstanceStep",
    value: function findInstanceStep(definitionStepId, instance, instances) {
      if (!instance || !instance.steps) return;
      var instanceStep = instance.steps.find(function (s) {
        return s.stepDefinitionId.toString() === definitionStepId;
      });
      if (instanceStep) return instanceStep;
      return this.findInstanceStep(definitionStepId, instances[instance.parent.instance], instances);
    }
  }, {
    key: "secondaryName",
    get: function get() {
      return this.context.secondaryName;
    },
    set: function set(typeLabel) {// throw it away
    }
  }]);

  return WorkflowContext;
}(_context5.default);

exports.default = WorkflowContext;

_defineProperty(WorkflowContext, "global", false);

_defineProperty(WorkflowContext, "type", 'workflow-context');

_defineProperty(WorkflowContext, "displayName", 'Workflow Context');

_defineProperty(WorkflowContext, "returnTypes", _returnTypes.ALL);
//# sourceMappingURL=workflow-context.js.map
