"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _context4 = _interopRequireDefault(require("../data-dictionary/context"));

var _workflowContext = _interopRequireDefault(require("./workflow-context"));

var _utils = require("./utils");

var _returnTypes = require("../data-dictionary/return-types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var WorkflowContexts =
/*#__PURE__*/
function (_Context) {
  _inherits(WorkflowContexts, _Context);

  function WorkflowContexts() {
    _classCallCheck(this, WorkflowContexts);

    return _possibleConstructorReturn(this, _getPrototypeOf(WorkflowContexts).apply(this, arguments));
  }

  _createClass(WorkflowContexts, [{
    key: "getChildren",
    value: function () {
      var _getChildren = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(filter) {
        var _this = this;

        var ctx, _this$data, ancestry, position, workflowCtxs, regex;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                ctx = this.ctx;
                _this$data = this.data, ancestry = _this$data.ancestry, position = _this$data.position;
                workflowCtxs = (0, _utils.getWorkflowRelevantContexts)(ancestry, position, this.returnTypes);

                if (filter) {
                  regex = new RegExp(filter, 'ig');
                  workflowCtxs = workflowCtxs.filter(function (_ref) {
                    var context = _ref.context;
                    return !ctx.getDeflatedContextName(context).search(regex);
                  });
                }

                return _context2.abrupt("return", Promise.all(workflowCtxs.map(
                /*#__PURE__*/
                function () {
                  var _ref2 = _asyncToGenerator(
                  /*#__PURE__*/
                  regeneratorRuntime.mark(function _callee(workflowCtx) {
                    var context, step, data;
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            context = workflowCtx.context, step = workflowCtx.step;
                            _context.next = 3;
                            return _this.ctx.inflate(context, _this.returnTypes);

                          case 3:
                            _context.t0 = _context.sent;
                            _context.t1 = step.ancestry;
                            _context.t2 = step.step._id;
                            data = {
                              context: _context.t0,
                              ancestry: _context.t1,
                              stepId: _context.t2
                            };
                            return _context.abrupt("return", new _workflowContext.default(_this, _this.returnTypes, data, ctx));

                          case 8:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, this);
                  }));

                  return function (_x2) {
                    return _ref2.apply(this, arguments);
                  };
                }())));

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function getChildren(_x) {
        return _getChildren.apply(this, arguments);
      };
    }()
  }, {
    key: "isEqual",
    value: function isEqual(ctx) {
      return ctx && ctx.type === this.type;
    }
  }, {
    key: "deflate",
    value: function deflate() {
      var valueList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var parent = this.parent,
          type = this.type,
          name = this.name;
      if (parent) parent.deflate(valueList);
      valueList.push({
        type: type,
        name: name,
        requiresParent: false
      });
      return valueList;
    }
  }], [{
    key: "inflate",
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(ctx, deflated, parent, scope) {
        var ancestry, position;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                ancestry = scope.ancestry, position = scope.position;
                return _context3.abrupt("return", {
                  ancestry: ancestry,
                  position: position
                });

              case 2:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function inflate(_x3, _x4, _x5, _x6) {
        return _inflate.apply(this, arguments);
      };
    }()
  }]);

  return WorkflowContexts;
}(_context4.default);

exports.default = WorkflowContexts;

_defineProperty(WorkflowContexts, "global", false);

_defineProperty(WorkflowContexts, "type", 'workflow-contexts');

_defineProperty(WorkflowContexts, "displayName", 'Workflow Data');

_defineProperty(WorkflowContexts, "returnTypes", _returnTypes.ALL);
//# sourceMappingURL=workflow-contexts.js.map
