"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = CoercionNotSupportedError;

function CoercionNotSupportedError(baseType, requestedCoerceType, valueToCoerce) {
  Error.captureStackTrace(this, this.constructor);
  this.message = "Cannot coerce ".concat(baseType, " into ").concat(requestedCoerceType, ": Operation not supported.");
  this.baseType = baseType;
  this.requestedCoerceType = requestedCoerceType;
  this.valueToCoerce = valueToCoerce;
  this.name = 'CoercionNotSupportedError';
}

CoercionNotSupportedError.prototype = Object.create(Error.prototype);
CoercionNotSupportedError.prototype.constructor = CoercionNotSupportedError;
//# sourceMappingURL=coercion-not-supported-error.js.map
