"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.ContextUtil = exports.DEFAULT_SCOPE = exports.apis = exports.contexts = void 0;

var _lodash = require("lodash");

var _axios = _interopRequireDefault(require("axios"));

var _context2 = _interopRequireDefault(require("./context"));

var _root = _interopRequireDefault(require("./root"));

var _globalCategories = _interopRequireDefault(require("./global-categories"));

var _globalConnections = _interopRequireDefault(require("./global-connections"));

var _globalForms = _interopRequireDefault(require("./global-forms"));

var _globalGroups = _interopRequireDefault(require("./global-groups"));

var _globalUsers = _interopRequireDefault(require("./global-users"));

var _category = _interopRequireDefault(require("./global-categories/category"));

var _connection = _interopRequireDefault(require("./global-connections/connection"));

var _form = _interopRequireDefault(require("./global-forms/form"));

var _group = _interopRequireDefault(require("./global-groups/group"));

var _user = _interopRequireDefault(require("./global-users/user"));

var _role = _interopRequireDefault(require("./global-roles/role"));

var _fieldChecklist = _interopRequireDefault(require("./global-forms/field-checklist"));

var _fieldCoreGroupMultiselect = _interopRequireDefault(require("./global-forms/field-core-group-multiselect"));

var _fieldCoreGroupTypeahead = _interopRequireDefault(require("./global-forms/field-core-group-typeahead"));

var _fieldCoreSurveyGrid = _interopRequireDefault(require("./global-forms/field-core-survey-grid"));

var _fieldCoreUserMultiselect = _interopRequireDefault(require("./global-forms/field-core-user-multiselect"));

var _fieldCoreUserTypeahead = _interopRequireDefault(require("./global-forms/field-core-user-typeahead"));

var _fieldCountryDropdown = _interopRequireDefault(require("./global-forms/field-country-dropdown"));

var _fieldDatePicker = _interopRequireDefault(require("./global-forms/field-date-picker"));

var _fieldDropDown = _interopRequireDefault(require("./global-forms/field-drop-down"));

var _fieldFormsMultiselect = _interopRequireDefault(require("./global-forms/field-forms-multiselect"));

var _fieldFormsPropertyView = _interopRequireDefault(require("./global-forms/field-forms-property-view"));

var _fieldFormsTypeahead = _interopRequireDefault(require("./global-forms/field-forms-typeahead"));

var _fieldLanguageDropdown = _interopRequireDefault(require("./global-forms/field-language-dropdown"));

var _fieldNumberInput = _interopRequireDefault(require("./global-forms/field-number-input"));

var _fieldRadioButton = _interopRequireDefault(require("./global-forms/field-radio-button"));

var _formFieldOption = _interopRequireDefault(require("./global-forms/form-field-option"));

var _fieldRichTextArea = _interopRequireDefault(require("./global-forms/field-rich-text-area"));

var _fieldStateProvinceDropdown = _interopRequireDefault(require("./global-forms/field-state-province-dropdown"));

var _fieldTextArea = _interopRequireDefault(require("./global-forms/field-text-area"));

var _fieldTextInput = _interopRequireDefault(require("./global-forms/field-text-input"));

var _textInput = _interopRequireDefault(require("./global-inputs/text-input"));

var _numericInput = _interopRequireDefault(require("./global-inputs/numeric-input"));

var _category2 = _interopRequireDefault(require("../api/category"));

var _connection2 = _interopRequireDefault(require("../api/connection"));

var _flowInsts = _interopRequireDefault(require("../api/flow-insts"));

var _flow = _interopRequireDefault(require("../api/flow"));

var _form2 = _interopRequireDefault(require("../api/form"));

var _group2 = _interopRequireDefault(require("../api/group"));

var _role2 = _interopRequireDefault(require("../api/role"));

var _user2 = _interopRequireDefault(require("../api/user"));

var _returnTypes = require("./return-types");

var _extensions = require("../extensions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var i18n = {
  UNSUPPORTED_TYPE: 'Cannot getContextType of a non-deflated context'
};
var contexts = [_root.default, _globalCategories.default, _globalConnections.default, _globalForms.default, _globalGroups.default, _globalUsers.default, _category.default, _connection.default, _form.default, _group.default, _user.default, _role.default, _fieldChecklist.default, _fieldCoreGroupMultiselect.default, _fieldCoreGroupTypeahead.default, _fieldCoreSurveyGrid.default, _fieldCoreUserMultiselect.default, _fieldCoreUserTypeahead.default, _fieldCountryDropdown.default, _fieldDatePicker.default, _fieldDropDown.default, _fieldFormsMultiselect.default, _fieldFormsPropertyView.default, _fieldFormsTypeahead.default, _fieldLanguageDropdown.default, _fieldNumberInput.default, _fieldRadioButton.default, _formFieldOption.default, _fieldRichTextArea.default, _fieldStateProvinceDropdown.default, _fieldTextArea.default, _fieldTextInput.default, _textInput.default, _numericInput.default].concat(_extensions.contexts);
exports.contexts = contexts;
var apis = [_category2.default, _connection2.default, _flowInsts.default, _flow.default, _form2.default, _group2.default, _user2.default, _role2.default].concat(_extensions.apis);
exports.apis = apis;
var DEFAULT_SCOPE = {
  axios: _axios.default,
  returnTypes: _returnTypes.ALL
};
exports.DEFAULT_SCOPE = DEFAULT_SCOPE;

var ContextUtil =
/*#__PURE__*/
function () {
  _createClass(ContextUtil, null, [{
    key: "getDeflatedContext",
    value: function getDeflatedContext(deflated) {
      // TODO: make the context handle providing basic info from a deflated array
      if (!(0, _lodash.isArray)(deflated)) throw new Error(i18n.UNSUPPORTED_TYPE);
      return (0, _lodash.last)(deflated);
    }
  }, {
    key: "getDeflatedContextType",
    value: function getDeflatedContextType(deflated) {
      if (!(0, _lodash.isArray)(deflated)) throw new Error(i18n.UNSUPPORTED_TYPE);
      return ContextUtil.getDeflatedContext(deflated).type;
    }
  }, {
    key: "getDeflatedContextName",
    value: function getDeflatedContextName(deflated) {
      if (!(0, _lodash.isArray)(deflated)) throw new Error(i18n.UNSUPPORTED_TYPE);
      return ContextUtil.getDeflatedContext(deflated).name;
    }
  }]);

  function ContextUtil(scope) {
    _classCallCheck(this, ContextUtil);

    this.contexts = contexts;
    this.contextMap = (0, _lodash.keyBy)(contexts, 'type');
    this.Root = _root.default;
    this.scope = Object.assign({}, DEFAULT_SCOPE, scope);
    this.apiSet = apis;
    this.apis = this.initAPIs();
    this.initRoot();
  }

  _createClass(ContextUtil, [{
    key: "initAPIs",
    value: function initAPIs() {
      var _this = this;

      var constructed = this.apiSet.map(function (Api) {
        return new Api(_this.scope.axios);
      });
      return (0, _lodash.keyBy)(constructed, function (c) {
        return c.constructor.API_KEY;
      });
    }
  }, {
    key: "initRoot",
    value: function initRoot(returnTypes) {
      this.root = new this.Root(null, returnTypes || this.scope.returnTypes, null, this);
      return this.root;
    }
  }, {
    key: "getRoot",
    value: function getRoot() {
      return this.root || this.initRoot();
    }
  }, {
    key: "addContext",
    value: function addContext(Context) {
      this.contexts.push(Context);
      this.contextMap = (0, _lodash.keyBy)(this.contexts, 'type');
    }
  }, {
    key: "addAPI",
    value: function addAPI(Api) {
      this.apiSet.push(Api);
      this.apis = this.initAPIs();
    }
  }, {
    key: "deflate",
    value: function deflate(value) {
      if (!(value instanceof _context2.default)) return value;
      return value.deflate();
    }
    /**
     * Recontitute contexts that have been stored
     * @param {Array} deflated The array of deflated values
     */

  }, {
    key: "inflate",
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(deflated) {
        var returnTypes,
            scope,
            contexts,
            length,
            i,
            defd,
            parent,
            _Context,
            data,
            ctx,
            _args = arguments;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                returnTypes = _args.length > 1 && _args[1] !== undefined ? _args[1] : '*';
                scope = this.scope;
                contexts = [];
                length = (0, _lodash.get)(deflated, 'length', 0);
                i = 0;

              case 5:
                if (!(i < length)) {
                  _context.next = 17;
                  break;
                }

                defd = deflated[i];
                parent = i > 0 ? contexts[i - 1] : undefined;
                _Context = this.contextMap[defd.type];
                _context.next = 11;
                return _Context.inflate(this, defd, parent, scope);

              case 11:
                data = _context.sent;
                ctx = _Context.type === this.Root.type ? this.root || new _root.default(parent, returnTypes, data, this) : new _Context(parent, returnTypes, data, this);
                contexts[i] = ctx;

              case 14:
                i++;
                _context.next = 5;
                break;

              case 17:
                return _context.abrupt("return", contexts[contexts.length - 1]);

              case 18:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function inflate(_x) {
        return _inflate.apply(this, arguments);
      };
    }()
  }, {
    key: "getDeflatedContextType",
    value: function getDeflatedContextType(deflated) {
      if (!(0, _lodash.isArray)(deflated)) throw new Error(i18n.UNSUPPORTED_TYPE);
      return (0, _lodash.last)(deflated).type;
    }
  }, {
    key: "getDeflatedContextName",
    value: function getDeflatedContextName(deflated) {
      if (!(0, _lodash.isArray)(deflated)) throw new Error(i18n.UNSUPPORTED_TYPE);
      return (0, _lodash.last)(deflated).name;
    }
  }, {
    key: "getRootParent",
    value: function getRootParent(value) {
      if (!value) return undefined;
      var parent = value.getParent();
      if (parent) return this.getRootParent(parent);
      return value.type === this.Root.type ? value : undefined;
    }
  }]);

  return ContextUtil;
}();

exports.ContextUtil = ContextUtil;

_defineProperty(ContextUtil, "contextToArray", function (context) {
  var array = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  if (!context) return array;
  array.unshift(context);

  if (context.parent && context.parent.type !== 'root') {
    ContextUtil.contextToArray(context.parent, array);
  }

  return array;
});

var contextUtil = new ContextUtil();
var _default = contextUtil;
exports.default = _default;
//# sourceMappingURL=context-utils.js.map
