"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _returnTypes = require("./return-types");

var _shorthash = _interopRequireDefault(require("shorthash"));

var _operators = require("./operators");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DEFAULTS = {
  returnTypes: '*',
  filter: {
    limit: 10
  }
  /**
   * Base Context Class
   */

};

var Context =
/*#__PURE__*/
function () {
  _createClass(Context, null, [{
    key: "inflate",

    /**
     * Not yet implemented
     * @abstract
     */
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(deflated) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                throw new Error('Not yet implemented');

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function inflate(_x) {
        return _inflate.apply(this, arguments);
      };
    }()
    /**
     * Construct new Context
     * @param {Array|string} returnTypes The array of return types or '*' for all
     * @param {Object} parent The parent context
     * @param {Object} data Any data that should be available
     */

  }]);

  function Context(parent) {
    var returnTypes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULTS['returnTypes'];
    var data = arguments.length > 2 ? arguments[2] : undefined;
    var ctx = arguments.length > 3 ? arguments[3] : undefined;

    _classCallCheck(this, Context);

    var _this$constructor = this.constructor,
        type = _this$constructor.type,
        typeLabel = _this$constructor.typeLabel,
        treatAsType = _this$constructor.treatAsType,
        displayName = _this$constructor.displayName,
        matchTypes = _this$constructor.matchTypes,
        preferredOperators = _this$constructor.preferredOperators,
        hasEnumerableValues = _this$constructor.hasEnumerableValues;
    this.type = type;
    this.treatAsType = treatAsType;
    this.name = displayName;
    this.secondaryName = typeLabel;
    this.match = matchTypes;
    this.preferredOperators = preferredOperators || [];
    this.hasEnumerableValues = hasEnumerableValues;
    this.parent = parent;
    this.returnTypes = returnTypes;
    this.data = data;
    this.ctx = ctx;
  }

  _createClass(Context, [{
    key: "getParent",
    value: function getParent() {
      return this.parent;
    }
    /**
     * Not yet implemented
     * @abstract
     * @param {dunno} filter
     */

  }, {
    key: "getChildren",
    value: function () {
      var _getChildren = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(filter) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                throw new Error('Not yet implemented');

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function getChildren(_x2) {
        return _getChildren.apply(this, arguments);
      };
    }()
  }, {
    key: "getData",
    value: function () {
      var _getData = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3() {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt("return", this.data);

              case 1:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function getData() {
        return _getData.apply(this, arguments);
      };
    }()
  }, {
    key: "setData",
    value: function setData(data) {
      this.data = data;
    }
  }, {
    key: "isLeaf",
    value: function isLeaf() {
      return false;
    }
  }, {
    key: "isEqual",
    value: function isEqual(ctx) {
      return (0, _lodash.isEqual)(this, ctx);
    }
  }, {
    key: "matches",
    value: function matches(match) {
      if (!this.match || !match) return false;
      if (match === _returnTypes.ALL) return true;
      var thisMatch = (0, _lodash.isArray)(this.match) ? this.match : [this.match];
      var thatMatch = (0, _lodash.isArray)(match) ? match : [match];
      return thisMatch.some(function (tm) {
        return thatMatch.includes(tm);
      }) || false;
    }
    /**
     * Not yet implemented
     * @abstract
     */

  }, {
    key: "deflate",
    value: function deflate() {
      throw new Error('Not yet implemented');
    }
    /**
     * Not yet implemented
     * @abstract
     */

  }, {
    key: "getValue",
    value: function () {
      var _getValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4() {
        var valueMap,
            parent,
            _args4 = arguments;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                valueMap = _args4.length > 0 && _args4[0] !== undefined ? _args4[0] : {};
                parent = this.parent;

                if (!parent) {
                  _context4.next = 5;
                  break;
                }

                _context4.next = 5;
                return parent.getValue(valueMap);

              case 5:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      return function getValue() {
        return _getValue.apply(this, arguments);
      };
    }()
  }, {
    key: "toString",
    value: function toString() {
      return this.parent ? "".concat(this.parent.toString(), " > ").concat(this.name) : this.name;
    }
  }, {
    key: "toShortString",
    value: function toShortString() {
      return this.name;
    }
  }, {
    key: "hash",
    value: function hash() {
      return this.parent ? "".concat(this.parent.hash(), ":").concat(this.shortHash()) : this.shortHash();
    }
  }, {
    key: "shortHash",
    value: function shortHash() {
      return "".concat(_shorthash.default.unique(this.type), "-").concat(_shorthash.default.unique(this.name));
    } // --- Utility Functions ---

    /**
     * Return the filtered set of passed contexts
     */

  }, {
    key: "reduceByReturnType",
    value: function reduceByReturnType(contexts) {
      var _this = this;

      return contexts.filter(function (Context) {
        return Context.returnTypes === '*' || Context.returnTypes.some(function (type) {
          return _this.returnTypes.includes(type);
        });
      });
    }
  }]);

  return Context;
}();

exports.default = Context;

_defineProperty(Context, "global", true);

_defineProperty(Context, "type", 'base-context');

_defineProperty(Context, "treatAsType", undefined);

_defineProperty(Context, "displayName", 'Data Source');

_defineProperty(Context, "returnTypes", _returnTypes.ALL);

_defineProperty(Context, "matchTypes", false);

_defineProperty(Context, "preferredOperators", (0, _operators.names)(_operators.BEGINS_WITH, _operators.CONTAINS, _operators.DOES_NOT_BEGIN_WITH, _operators.DOES_NOT_CONTAIN, _operators.DOES_NOT_END_WITH, _operators.ENDS_WITH, _operators.IS, _operators.IS_EMPTY, _operators.IS_NOT, _operators.IS_NOT_EMPTY));
//# sourceMappingURL=context.js.map
