"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _context7 = _interopRequireDefault(require("../context"));

var _role = _interopRequireDefault(require("../global-roles/role"));

var _returnTypes = require("../return-types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Category =
/*#__PURE__*/
function (_Context) {
  _inherits(Category, _Context);

  _createClass(Category, null, [{
    key: "inflate",
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(ctx, deflated) {
        var category;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return ctx.apis.categories.get(deflated.id);

              case 2:
                category = _context.sent;
                return _context.abrupt("return", category);

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function inflate(_x, _x2) {
        return _inflate.apply(this, arguments);
      };
    }()
  }]);

  function Category(parent, returnTypes, data, ctx) {
    var _this;

    _classCallCheck(this, Category);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Category).call(this, parent, returnTypes, data, ctx));
    _this.name = data.name;
    return _this;
  }

  _createClass(Category, [{
    key: "getChildren",
    value: function () {
      var _getChildren = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(filter) {
        var _this2 = this;

        var category, children, categoryData, roles;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.getData();

              case 2:
                category = _context2.sent;
                children = [];

                if (category) {
                  _context2.next = 6;
                  break;
                }

                return _context2.abrupt("return", children);

              case 6:
                if (!category.parentId) {
                  _context2.next = 11;
                  break;
                }

                _context2.next = 9;
                return this.ctx.apis.categories.get(category.parentId);

              case 9:
                categoryData = _context2.sent;
                children.push(new Category(this, this.returnTypes, categoryData, this.ctx));

              case 11:
                if (category.roleSchemas) {
                  roles = category.roleSchemas.map(function (role) {
                    return new _role.default(_this2, _this2.returnTypes, role, _this2.ctx);
                  });
                  children.push.apply(children, _toConsumableArray(roles));
                }

                return _context2.abrupt("return", children);

              case 13:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function getChildren(_x3) {
        return _getChildren.apply(this, arguments);
      };
    }()
  }, {
    key: "isLeaf",
    value: function isLeaf() {
      if (!this.data || !this.data.roleSchemas) return true;
      return !this.data.roleSchemas.length;
    }
  }, {
    key: "deflate",
    value: function deflate() {
      var valueList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var parent = this.parent,
          type = this.type,
          name = this.name,
          data = this.data;
      if (parent) parent.deflate(valueList);
      valueList.push({
        type: type,
        name: name,
        id: data.id,
        requiresParent: false
      });
      return valueList;
    }
    /**
     * This function should account for the following scenarios:
     * 1. The category is just a category and represents a classification
     * 1b. The category is a parent of a role classification
     * 2. The category is related to a group in which case it may represent a group
     * @param {*} valueMap
     */

  }, {
    key: "getValue",
    value: function () {
      var _getValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3() {
        var valueMap,
            data,
            parent,
            parentValue,
            type,
            treatAsType,
            _args3 = arguments;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                valueMap = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : {};
                data = this.data, parent = this.parent;
                valueMap.category = {
                  value: data // If this category has an immediate parent that is a group, then this
                  // category represents the group that is related to the parent group, and
                  // not the category itself.

                };

                if (!parent) {
                  _context3.next = 10;
                  break;
                }

                _context3.next = 6;
                return parent.getValue(valueMap);

              case 6:
                parentValue = _context3.sent;
                type = parent.type, treatAsType = parent.treatAsType;

                if (!(type === _returnTypes.GROUP || type === _returnTypes.GROUP_LIST || treatAsType === _returnTypes.GROUP || treatAsType === _returnTypes.GROUP_LIST)) {
                  _context3.next = 10;
                  break;
                }

                return _context3.abrupt("return", (0, _lodash.isArray)(parentValue) ? this.getGroupListData(parentValue, data) : this.getGroupData(parentValue, data));

              case 10:
                return _context3.abrupt("return", data);

              case 11:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function getValue() {
        return _getValue.apply(this, arguments);
      };
    }()
  }, {
    key: "getGroupListData",
    value: function () {
      var _getGroupListData = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5(groupList, data) {
        var _this3 = this;

        var promises;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                promises = groupList.map(
                /*#__PURE__*/
                function () {
                  var _ref = _asyncToGenerator(
                  /*#__PURE__*/
                  regeneratorRuntime.mark(function _callee4(val) {
                    return regeneratorRuntime.wrap(function _callee4$(_context4) {
                      while (1) {
                        switch (_context4.prev = _context4.next) {
                          case 0:
                            return _context4.abrupt("return", _this3.getGroupData(val, data));

                          case 1:
                          case "end":
                            return _context4.stop();
                        }
                      }
                    }, _callee4, this);
                  }));

                  return function (_x6) {
                    return _ref.apply(this, arguments);
                  };
                }());
                return _context5.abrupt("return", Promise.all(promises));

              case 2:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      return function getGroupListData(_x4, _x5) {
        return _getGroupListData.apply(this, arguments);
      };
    }()
  }, {
    key: "getGroupData",
    value: function () {
      var _getGroupData = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee6(group, data) {
        var parent;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                if (!group) {
                  _context6.next = 7;
                  break;
                }

                if (!group.parentId) {
                  _context6.next = 6;
                  break;
                }

                _context6.next = 4;
                return this.ctx.apis.groups.get(group.parentId);

              case 4:
                parent = _context6.sent;
                return _context6.abrupt("return", _objectSpread({}, data, {
                  group: parent
                }));

              case 6:
                return _context6.abrupt("return", data);

              case 7:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      return function getGroupData(_x7, _x8) {
        return _getGroupData.apply(this, arguments);
      };
    }()
  }]);

  return Category;
}(_context7.default);

exports.default = Category;

_defineProperty(Category, "global", true);

_defineProperty(Category, "type", 'category');

_defineProperty(Category, "treatAsType", _returnTypes.CATEGORY);

_defineProperty(Category, "returnTypes", [_returnTypes.CATEGORY, _returnTypes.GROUP, _returnTypes.ROLE, _returnTypes.TEXT, _returnTypes.USER]);

_defineProperty(Category, "matchTypes", [_returnTypes.CATEGORY, _returnTypes.TEXT]);

_defineProperty(Category, "preferredOperators", []);
//# sourceMappingURL=category.js.map
