"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _context4 = _interopRequireDefault(require("../context"));

var _returnTypes = require("../return-types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Connection =
/*#__PURE__*/
function (_Context) {
  _inherits(Connection, _Context);

  _createClass(Connection, null, [{
    key: "inflate",
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(ctx, deflated) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", ctx.apis.connections.get(deflated.id));

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function inflate(_x, _x2) {
        return _inflate.apply(this, arguments);
      };
    }()
  }]);

  function Connection(parent, returnTypes, data, ctx) {
    var _this;

    _classCallCheck(this, Connection);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Connection).call(this, parent, returnTypes, data, ctx));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getChildren",
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(filter) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", []);

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function (_x3) {
        return _ref.apply(this, arguments);
      };
    }());

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isLeaf", function () {
      return true;
    });

    _this.name = (0, _lodash.get)(data, 'name') || 'Connection Not Found';
    return _this;
  }

  _createClass(Connection, [{
    key: "isEqual",
    value: function isEqual(ctx) {
      if (!ctx || !ctx.data || !this.data) return false;
      return this.data.id === ctx.data.id;
    }
  }, {
    key: "deflate",
    value: function deflate() {
      var valueList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var parent = this.parent,
          type = this.type,
          name = this.name,
          data = this.data;
      if (parent) parent.deflate(valueList);
      valueList.push({
        type: type,
        name: name,
        id: data.id,
        requiresParent: false
      });
      return valueList;
    }
    /**
     * Not yet implemented
     * @abstract
     */

  }, {
    key: "getValue",
    value: function () {
      var _getValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3() {
        var valueMap,
            parent,
            connection,
            _args3 = arguments;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                valueMap = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : {};
                parent = this.parent;

                if (!parent) {
                  _context3.next = 5;
                  break;
                }

                _context3.next = 5;
                return parent.getValue(valueMap);

              case 5:
                if (!this.data) {
                  _context3.next = 9;
                  break;
                }

                connection = Object.assign({
                  toString: function toString() {
                    return this.name;
                  }
                }, this.data);
                valueMap.connection = {
                  value: connection
                };
                return _context3.abrupt("return", connection);

              case 9:
                return _context3.abrupt("return", undefined);

              case 10:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function getValue() {
        return _getValue.apply(this, arguments);
      };
    }()
  }]);

  return Connection;
}(_context4.default);

exports.default = Connection;

_defineProperty(Connection, "global", true);

_defineProperty(Connection, "type", 'connection');

_defineProperty(Connection, "treatAsType", _returnTypes.CONNECTION);

_defineProperty(Connection, "returnTypes", [_returnTypes.CONNECTION]);

_defineProperty(Connection, "matchTypes", [_returnTypes.CONNECTION]);

_defineProperty(Connection, "preferredOperators", []);
//# sourceMappingURL=connection.js.map
