"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _field = _interopRequireDefault(require("./field"));

var _formFieldOption = _interopRequireDefault(require("./form-field-option"));

var _returnTypes = require("../return-types");

var _operators = require("../operators");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FieldChecklist =
/*#__PURE__*/
function (_Field) {
  _inherits(FieldChecklist, _Field);

  function FieldChecklist() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FieldChecklist);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FieldChecklist)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getChildren",
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(match) {
        var options, regex;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                options = (0, _lodash.get)(_assertThisInitialized(_assertThisInitialized(_this)), 'data.details.options', []);

                if (match) {
                  regex = new RegExp(match, 'ig');
                  options = (0, _lodash.filter)(options, function (option) {
                    return !option.lbl.search(regex);
                  });
                }

                return _context.abrupt("return", options.map(function (option) {
                  return new _formFieldOption.default(_assertThisInitialized(_assertThisInitialized(_this)), _this.returnTypes, option, _this.ctx);
                }));

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isLeaf", function () {
      return false;
    });

    return _this;
  }

  _createClass(FieldChecklist, [{
    key: "getValue",
    value: function () {
      var _getValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var valueMap,
            data,
            parent,
            _valueMap$formfill,
            document,
            schema,
            optionKey,
            matches,
            labels,
            _args2 = arguments;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                valueMap = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : {};
                data = this.data, parent = this.parent;

                if (!parent) {
                  _context2.next = 5;
                  break;
                }

                _context2.next = 5;
                return parent.getValue(valueMap);

              case 5:
                if (!(!valueMap.formfill || !valueMap.formfill.document || !valueMap.formfill.schema)) {
                  _context2.next = 7;
                  break;
                }

                return _context2.abrupt("return");

              case 7:
                _valueMap$formfill = valueMap.formfill, document = _valueMap$formfill.document, schema = _valueMap$formfill.schema;
                optionKey = document.data[data.formKey];
                matches = (0, _lodash.filter)(schema.schema[data.formKey].details.options, function (option) {
                  return (0, _lodash.includes)(optionKey, option.key);
                });
                labels = (0, _lodash.map)(matches, function (match) {
                  return match.lbl || '?';
                });
                valueMap.field = {
                  value: labels
                };
                return _context2.abrupt("return", labels);

              case 13:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function getValue() {
        return _getValue.apply(this, arguments);
      };
    }()
  }]);

  return FieldChecklist;
}(_field.default);

exports.default = FieldChecklist;

_defineProperty(FieldChecklist, "typeLabel", 'Checkboxes');

_defineProperty(FieldChecklist, "type", 'field-checklist');

_defineProperty(FieldChecklist, "treatAsType", _returnTypes.TEXT_LIST);

_defineProperty(FieldChecklist, "returnTypes", [_returnTypes.TEXT_LIST, _returnTypes.NUMBER_LIST]);

_defineProperty(FieldChecklist, "matchTypes", [_returnTypes.TEXT_LIST, _returnTypes.NUMBER_LIST]);

_defineProperty(FieldChecklist, "preferredOperators", (0, _operators.names)(_operators.CONTAINS, _operators.DOES_NOT_CONTAIN, _operators.IS_EMPTY, _operators.IS_NOT_EMPTY));

_defineProperty(FieldChecklist, "hasEnumerableValues", true);
//# sourceMappingURL=field-checklist.js.map
