"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _field = _interopRequireDefault(require("./field"));

var _category = _interopRequireDefault(require("../global-categories/category"));

var _role = _interopRequireDefault(require("../global-roles/role"));

var _returnTypes = require("../return-types");

var _operators = require("../operators");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FieldCoreGroupTypeahead =
/*#__PURE__*/
function (_Field) {
  _inherits(FieldCoreGroupTypeahead, _Field);

  function FieldCoreGroupTypeahead() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FieldCoreGroupTypeahead);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FieldCoreGroupTypeahead)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getChildren",
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(filter) {
        var categoryId, category, parentId, roleSchemas, children, pData;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                categoryId = _this.data.details.categoryId;
                _context.next = 3;
                return _this.ctx.apis.categories.get(categoryId);

              case 3:
                category = _context.sent;
                parentId = category.parentId, roleSchemas = category.roleSchemas;
                children = roleSchemas.map(function (role) {
                  return new _role.default(_assertThisInitialized(_assertThisInitialized(_this)), _this.returnTypes, role, _this.ctx);
                });

                if (!parentId) {
                  _context.next = 11;
                  break;
                }

                _context.next = 9;
                return _this.ctx.apis.categories.get(parentId);

              case 9:
                pData = _context.sent;
                children.unshift(new _category.default(_assertThisInitialized(_assertThisInitialized(_this)), _this.returnTypes, pData, _this.ctx));

              case 11:
                return _context.abrupt("return", children);

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isLeaf", function () {
      return false;
    });

    return _this;
  }

  _createClass(FieldCoreGroupTypeahead, [{
    key: "deflate",
    value: function deflate() {
      var valueList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var parent = this.parent,
          type = this.type,
          name = this.name,
          data = this.data;
      if (parent) parent.deflate(valueList);
      valueList.push({
        type: type,
        name: name,
        data: data,
        formKey: data.formKey,
        requiresParent: false
      });
      return valueList;
    }
  }, {
    key: "getValue",
    value: function () {
      var _getValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var valueMap,
            data,
            parent,
            document,
            groupData,
            group,
            _args2 = arguments;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                valueMap = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : {};
                data = this.data, parent = this.parent;

                if (!parent) {
                  _context2.next = 5;
                  break;
                }

                _context2.next = 5;
                return parent.getValue(valueMap);

              case 5:
                if (!(!valueMap.formfill || !valueMap.formfill.document)) {
                  _context2.next = 7;
                  break;
                }

                return _context2.abrupt("return");

              case 7:
                document = valueMap.formfill.document;
                groupData = document.data[data.formKey];

                if (!(groupData && groupData.id)) {
                  _context2.next = 18;
                  break;
                }

                _context2.next = 12;
                return this.ctx.apis.groups.get(groupData.id);

              case 12:
                group = _context2.sent;

                group.toString = function () {
                  return this.name;
                };

                valueMap.field = {
                  value: group
                };
                return _context2.abrupt("return", group);

              case 18:
                valueMap.field = {
                  value: null
                };
                return _context2.abrupt("return", null);

              case 20:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function getValue() {
        return _getValue.apply(this, arguments);
      };
    }()
  }], [{
    key: "inflate",
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(ctx, deflated, parent) {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt("return", deflated.data);

              case 1:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function inflate(_x2, _x3, _x4) {
        return _inflate.apply(this, arguments);
      };
    }()
  }]);

  return FieldCoreGroupTypeahead;
}(_field.default);

exports.default = FieldCoreGroupTypeahead;

_defineProperty(FieldCoreGroupTypeahead, "typeLabel", 'GroupTypeahead');

_defineProperty(FieldCoreGroupTypeahead, "type", 'field-core-group-typeahead');

_defineProperty(FieldCoreGroupTypeahead, "treatAsType", _returnTypes.GROUP);

_defineProperty(FieldCoreGroupTypeahead, "returnTypes", [_returnTypes.GROUP, _returnTypes.ROLE, _returnTypes.TEXT]);

_defineProperty(FieldCoreGroupTypeahead, "matchTypes", [_returnTypes.GROUP, _returnTypes.TEXT]);

_defineProperty(FieldCoreGroupTypeahead, "preferredOperators", (0, _operators.names)(_operators.IS, _operators.IS_EMPTY, _operators.IS_NOT_EMPTY));
//# sourceMappingURL=field-core-group-typeahead.js.map
