"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.PROVINCES = exports.STATES = void 0;

var _lodash = require("lodash");

var _field = _interopRequireDefault(require("./field"));

var _returnTypes = require("../return-types");

var _textInput = _interopRequireDefault(require("../global-inputs/text-input"));

var _operators = require("../operators");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// TODO: this is hard-coded into formbot so it must be hardcoded here as well
var STATES = ['Alabama', 'Alaska', 'Arizona', 'Arkansas', 'California', 'Colorado', 'Connecticut', 'Delaware', 'Florida', 'Georgia', 'Hawaii', 'Idaho', 'Illinois', 'Indiana', 'Iowa', 'Kansas', 'Kentucky', 'Louisiana', 'Maine', 'Maryland', 'Massachusetts', 'Michigan', 'Minnesota', 'Mississippi', 'Missouri', 'Montana', 'Nebraska', 'Nevada', 'New Hampshire', 'New Jersey', 'New Mexico', 'New York', 'North Carolina', 'North Dakota', 'Ohio', 'Oklahoma', 'Oregon', 'Pennsylvania', 'Rhode Island', 'South Carolina', 'South Dakota', 'Tennessee', 'Texas', 'Utah', 'Vermont', 'Virginia', 'Washington', 'West Virginia', 'Wisconsin', 'Wyoming'];
exports.STATES = STATES;
var PROVINCES = ['Alberta', 'British Columbia', 'Manitoba', 'New Brunswick', 'Newfoundland and Labrador', 'Northwest Territories', 'Nova Scotia', 'Nunavut', 'Ontario', 'Prince Edward Island', 'Quebec', 'Saskatchewan', 'Yukon'];
exports.PROVINCES = PROVINCES;

var FieldStateProvinceDropDown =
/*#__PURE__*/
function (_Field) {
  _inherits(FieldStateProvinceDropDown, _Field);

  function FieldStateProvinceDropDown() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FieldStateProvinceDropDown);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FieldStateProvinceDropDown)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getChildren",
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(match) {
        var sAndP, states, regex, children;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                sAndP = STATES.concat(PROVINCES).sort();
                states = sAndP;

                if (match) {
                  regex = new RegExp(match, 'ig');
                  states = (0, _lodash.filter)(sAndP, function (state) {
                    return !state.search(regex);
                  });
                }

                children = states.map(function (state) {
                  return new _textInput.default(_assertThisInitialized(_assertThisInitialized(_this)), _this.returnTypes, state, _this.ctx);
                });
                return _context.abrupt("return", children);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isLeaf", function () {
      return false;
    });

    return _this;
  }

  return FieldStateProvinceDropDown;
}(_field.default);

exports.default = FieldStateProvinceDropDown;

_defineProperty(FieldStateProvinceDropDown, "typeLabel", 'StateDropdown');

_defineProperty(FieldStateProvinceDropDown, "type", 'field-state-province-drop-down');

_defineProperty(FieldStateProvinceDropDown, "treatAsType", _returnTypes.TEXT);

_defineProperty(FieldStateProvinceDropDown, "returnTypes", [_returnTypes.TEXT]);

_defineProperty(FieldStateProvinceDropDown, "matchTypes", [_returnTypes.TEXT]);

_defineProperty(FieldStateProvinceDropDown, "preferredOperators", (0, _operators.names)(_operators.IS, _operators.IS_NOT, _operators.IS_EMPTY, _operators.IS_NOT_EMPTY));

_defineProperty(FieldStateProvinceDropDown, "hasEnumerableValues", true);
//# sourceMappingURL=field-state-province-dropdown.js.map
