"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _context4 = _interopRequireDefault(require("../context"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _lodash = require("lodash");

var _field = _interopRequireDefault(require("./field"));

var _fieldChecklist = _interopRequireDefault(require("./field-checklist"));

var _fieldCoreGroupMultiselect = _interopRequireDefault(require("./field-core-group-multiselect"));

var _fieldCoreGroupTypeahead = _interopRequireDefault(require("./field-core-group-typeahead"));

var _fieldCoreSurveyGrid = _interopRequireDefault(require("./field-core-survey-grid"));

var _fieldCoreUserMultiselect = _interopRequireDefault(require("./field-core-user-multiselect"));

var _fieldCoreUserTypeahead = _interopRequireDefault(require("./field-core-user-typeahead"));

var _fieldCountryDropdown = _interopRequireDefault(require("./field-country-dropdown"));

var _fieldDatePicker = _interopRequireDefault(require("./field-date-picker"));

var _fieldDropDown = _interopRequireDefault(require("./field-drop-down"));

var _fieldFormsMultiselect = _interopRequireDefault(require("./field-forms-multiselect"));

var _fieldFormsPropertyView = _interopRequireDefault(require("./field-forms-property-view"));

var _fieldFormsTypeahead = _interopRequireDefault(require("./field-forms-typeahead"));

var _fieldLanguageDropdown = _interopRequireDefault(require("./field-language-dropdown"));

var _fieldNumberInput = _interopRequireDefault(require("./field-number-input"));

var _fieldRadioButton = _interopRequireDefault(require("./field-radio-button"));

var _fieldRichTextArea = _interopRequireDefault(require("./field-rich-text-area"));

var _fieldStateProvinceDropdown = _interopRequireDefault(require("./field-state-province-dropdown"));

var _fieldTextArea = _interopRequireDefault(require("./field-text-area"));

var _fieldTextInput = _interopRequireDefault(require("./field-text-input"));

var _returnTypes = require("../return-types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var fieldList = {
  FieldChecklist: _fieldChecklist.default,
  FieldCoreGroupMultiselect: _fieldCoreGroupMultiselect.default,
  FieldCoreGroupTypeahead: _fieldCoreGroupTypeahead.default,
  FieldCoreSurvryGrid: _fieldCoreSurveyGrid.default,
  FieldCoreUserMultiselect: _fieldCoreUserMultiselect.default,
  FieldCoreUserTypeahead: _fieldCoreUserTypeahead.default,
  FieldCountryDropdown: _fieldCountryDropdown.default,
  FieldDatePicker: _fieldDatePicker.default,
  FieldDropdown: _fieldDropDown.default,
  FieldFormsMultiselect: _fieldFormsMultiselect.default,
  FieldFormsTypeahead: _fieldFormsTypeahead.default,
  FieldFormsPropertyView: _fieldFormsPropertyView.default,
  FieldLanguageDropdown: _fieldLanguageDropdown.default,
  FieldNumberInput: _fieldNumberInput.default,
  FieldRadioButton: _fieldRadioButton.default,
  FieldRichTextArea: _fieldRichTextArea.default,
  FieldStateProvinceDropdown: _fieldStateProvinceDropdown.default,
  FieldTextArea: _fieldTextArea.default,
  FieldTextInput: _fieldTextInput.default
};
var fieldMap = (0, _lodash.keyBy)(fieldList, 'typeLabel');
/**
 * Creates a Form Context
 *
 * @param {Object} parent The parent Context
 * @param {Array|String} returnTypes The array of contexts or '*' for all
 * @param {Object} data The parent Context
 */

var Form =
/*#__PURE__*/
function (_Context) {
  _inherits(Form, _Context);

  _createClass(Form, null, [{
    key: "inflate",
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(ctx, deflated) {
        var _ref, _ref2, form, schema, _form;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _bluebird.default.all([ctx.apis.forms.getForm({
                  id: deflated.id
                }), ctx.apis.forms.getSchema({
                  id: deflated.id
                })]);

              case 2:
                _ref = _context.sent;
                _ref2 = _slicedToArray(_ref, 2);
                form = _ref2[0];
                schema = _ref2[1];
                _form = Object.assign({}, schema, form);
                _form.schemaId = schema.id;
                return _context.abrupt("return", _form);

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function inflate(_x, _x2) {
        return _inflate.apply(this, arguments);
      };
    }()
  }]);

  function Form(parent, returnTypes, data, ctx) {
    var _this;

    _classCallCheck(this, Form);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Form).call(this, parent, returnTypes, data, ctx));

    _this.validate(data);

    _this.name = data.label;
    return _this;
  }

  _createClass(Form, [{
    key: "getChildren",
    value: function () {
      var _getChildren = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(match) {
        var _this2 = this;

        var form, fields, regex, myReturnTypes, children;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(!this.data || !this.data.id)) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt("return", []);

              case 2:
                _context2.next = 4;
                return this.ctx.apis.forms.getSchema(this.data);

              case 4:
                form = _context2.sent;

                if (match) {
                  regex = new RegExp(match, 'ig');
                  fields = (0, _lodash.filter)((0, _lodash.values)(form.schema), function (field) {
                    return !field.label.search(regex);
                  });
                } else {
                  fields = (0, _lodash.map)(form.schema, function (field) {
                    return field;
                  });
                }

                myReturnTypes = (0, _lodash.isArray)(this.returnTypes) ? this.returnTypes : [this.returnTypes];
                children = fields.map(function (field) {
                  var FieldContext = fieldMap[field.type] || _field.default;

                  if (myReturnTypes.includes(_returnTypes.ALL) || FieldContext.returnTypes === _returnTypes.ALL || FieldContext.returnTypes.some(function (type) {
                    return _this2.returnTypes.includes(type);
                  })) {
                    return new FieldContext(_this2, _this2.returnTypes, field, _this2.ctx);
                  }
                });
                return _context2.abrupt("return", (0, _lodash.compact)(children));

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function getChildren(_x3) {
        return _getChildren.apply(this, arguments);
      };
    }()
  }, {
    key: "isLeaf",
    value: function isLeaf() {
      return false;
    }
  }, {
    key: "deflate",
    value: function deflate() {
      var valueList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var parent = this.parent,
          type = this.type,
          name = this.name,
          data = this.data;
      if (parent) parent.deflate(valueList);
      valueList.push({
        type: type,
        name: name,
        id: data.id,
        requiresParent: false
      });
      return valueList;
    }
    /**
     * Expect the parent form to have provided a document containing values
     * @param {Object} valueMap a map of parent's output
     */

  }, {
    key: "getValue",
    value: function () {
      var _getValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3() {
        var valueMap,
            data,
            parent,
            formsAPI,
            responses,
            _args3 = arguments;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                valueMap = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : {};
                data = this.data, parent = this.parent;

                if (!parent) {
                  _context3.next = 5;
                  break;
                }

                _context3.next = 5;
                return parent.getValue(valueMap);

              case 5:
                formsAPI = this.ctx.apis.forms;
                _context3.next = 8;
                return _bluebird.default.props({
                  container: formsAPI.getForm({
                    id: data.id
                  }),
                  schema: formsAPI.getSchema({
                    id: data.id
                  })
                });

              case 8:
                responses = _context3.sent;
                valueMap.formfill = responses;
                return _context3.abrupt("return", responses);

              case 11:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function getValue() {
        return _getValue.apply(this, arguments);
      };
    }()
  }, {
    key: "isEqual",
    value: function isEqual(ctx) {
      return (0, _lodash.get)(this, 'data.id') === (0, _lodash.get)(ctx, 'data.id');
    } // --- Utility Functions ---

  }, {
    key: "validate",
    value: function validate(data) {
      if (!data || !data.id) {
        throw new Error('Cannot create a Form Context without propperly formatted form data');
      }
    }
  }]);

  return Form;
}(_context4.default);

exports.default = Form;

_defineProperty(Form, "global", false);

_defineProperty(Form, "type", 'formfill');

_defineProperty(Form, "typeLabel", 'Form');

_defineProperty(Form, "treatAsType", _returnTypes.FORM);

_defineProperty(Form, "returnTypes", _returnTypes.ALL);

_defineProperty(Form, "matchTypes", [_returnTypes.FORM, _returnTypes.TEXT]);

_defineProperty(Form, "preferredOperators", []);
//# sourceMappingURL=form.js.map
