"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _context7 = _interopRequireDefault(require("../context"));

var _category = _interopRequireDefault(require("../global-categories/category"));

var _role = _interopRequireDefault(require("../global-roles/role"));

var _returnTypes = require("../return-types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Group =
/*#__PURE__*/
function (_Context) {
  _inherits(Group, _Context);

  function Group(parent, returnTypes, data, ctx, secondaryName) {
    var _this;

    _classCallCheck(this, Group);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Group).call(this, parent, returnTypes, data, ctx));
    _this.name = data.name;
    _this.secondaryName = secondaryName;
    return _this;
  }

  _createClass(Group, [{
    key: "getChildren",
    value: function () {
      var _getChildren = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(filter) {
        var resp, parent, category, roles, children;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (this.data) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return", []);

              case 2:
                _context.next = 4;
                return Promise.all([this.getGroupParent(), this.getGroupCategory(this.data.categoryId)]);

              case 4:
                resp = _context.sent;
                parent = resp[0];
                category = resp[1];
                _context.next = 9;
                return this.getGroupRoles(category);

              case 9:
                roles = _context.sent;
                children = category ? [category].concat(roles) : roles;
                if (parent) children.unshift(parent);
                return _context.abrupt("return", children);

              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function getChildren(_x) {
        return _getChildren.apply(this, arguments);
      };
    }()
  }, {
    key: "getGroupCategory",
    value: function () {
      var _getGroupCategory = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(categoryId) {
        var categoryData;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (categoryId) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt("return");

              case 2:
                _context2.next = 4;
                return this.ctx.apis.categories.get(categoryId);

              case 4:
                categoryData = _context2.sent;
                return _context2.abrupt("return", new _category.default(this, this.returnTypes, categoryData, this.ctx));

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function getGroupCategory(_x2) {
        return _getGroupCategory.apply(this, arguments);
      };
    }()
  }, {
    key: "getGroupParent",
    value: function () {
      var _getGroupParent = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3() {
        var groupData, parentCategory;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (this.data.parentId) {
                  _context3.next = 2;
                  break;
                }

                return _context3.abrupt("return");

              case 2:
                _context3.next = 4;
                return this.ctx.apis.groups.get(this.data.parentId);

              case 4:
                groupData = _context3.sent;
                _context3.next = 7;
                return this.getGroupCategory((0, _lodash.get)(groupData, 'categoryId'));

              case 7:
                parentCategory = _context3.sent;
                return _context3.abrupt("return", new Group(this, this.returnTypes, groupData, this.ctx, (0, _lodash.get)(parentCategory, 'name')));

              case 9:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function getGroupParent() {
        return _getGroupParent.apply(this, arguments);
      };
    }()
  }, {
    key: "getGroupRoles",
    value: function () {
      var _getGroupRoles = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(category) {
        var _this2 = this;

        var cat, roles;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!this.data.roleSchemas) {
                  _context4.next = 2;
                  break;
                }

                return _context4.abrupt("return", this.data.roleSchemas.map(function (role) {
                  return new _role.default(_this2, _this2.returnTypes, role, _this2.ctx);
                }));

              case 2:
                _context4.t0 = category;

                if (_context4.t0) {
                  _context4.next = 7;
                  break;
                }

                _context4.next = 6;
                return this.getGroupCategory(this.data.categoryId);

              case 6:
                _context4.t0 = _context4.sent;

              case 7:
                cat = _context4.t0;

                if (cat) {
                  _context4.next = 10;
                  break;
                }

                return _context4.abrupt("return");

              case 10:
                _context4.next = 12;
                return category.getChildren();

              case 12:
                roles = _context4.sent;
                roles.forEach(function (role) {
                  role.parent = _this2;
                });
                return _context4.abrupt("return", roles);

              case 15:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      return function getGroupRoles(_x3) {
        return _getGroupRoles.apply(this, arguments);
      };
    }()
  }, {
    key: "deflate",
    value: function deflate() {
      var valueList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var parent = this.parent,
          type = this.type,
          name = this.name,
          data = this.data;
      if (parent) parent.deflate(valueList);
      valueList.push({
        type: type,
        name: name,
        data: {
          id: data.id
        },
        requiresParent: true
      });
      return valueList;
    }
  }, {
    key: "isLeaf",
    value: function isLeaf() {
      if (!this.data) return true;
      return false;
    }
  }, {
    key: "isEqual",
    value: function isEqual(value) {
      return (0, _lodash.get)(value, 'data.id') === (0, _lodash.get)(this, 'data.id');
    }
  }, {
    key: "getValue",
    value: function () {
      var _getValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5() {
        var valueMap,
            _args5 = arguments;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                valueMap = _args5.length > 0 && _args5[0] !== undefined ? _args5[0] : {};

                _get(_getPrototypeOf(Group.prototype), "getValue", this).call(this, valueMap);

                valueMap.groupId = this.data.id;
                return _context5.abrupt("return", this.data);

              case 4:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      return function getValue() {
        return _getValue.apply(this, arguments);
      };
    }()
  }], [{
    key: "inflate",
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee6(ctx, deflated) {
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                return _context6.abrupt("return", ctx.apis.groups.get(deflated.data.id));

              case 1:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      return function inflate(_x4, _x5) {
        return _inflate.apply(this, arguments);
      };
    }()
  }]);

  return Group;
}(_context7.default);

exports.default = Group;

_defineProperty(Group, "global", true);

_defineProperty(Group, "type", 'group');

_defineProperty(Group, "treatAsType", _returnTypes.GROUP);

_defineProperty(Group, "returnTypes", [_returnTypes.CATEGORY, _returnTypes.GROUP, _returnTypes.ROLE, _returnTypes.TEXT, _returnTypes.USER]);

_defineProperty(Group, "matchTypes", [_returnTypes.TEXT, _returnTypes.GROUP]);

_defineProperty(Group, "preferredOperators", []);
//# sourceMappingURL=group.js.map
