"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _context4 = _interopRequireDefault(require("../context"));

var _returnTypes = require("../return-types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Role =
/*#__PURE__*/
function (_Context) {
  _inherits(Role, _Context);

  _createClass(Role, null, [{
    key: "inflate",
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(ctx, deflated, parent) {
        var children, role;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return parent.getChildren({}, [_returnTypes.ROLE]);

              case 2:
                children = _context.sent;
                role = children.find(function (child) {
                  return child.type === Role.type && child.data.id === deflated.id;
                });
                return _context.abrupt("return", role.data);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function inflate(_x, _x2, _x3) {
        return _inflate.apply(this, arguments);
      };
    }()
  }]);

  function Role(parent, returnTypes, data, ctx) {
    var _this;

    _classCallCheck(this, Role);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Role).call(this, parent, returnTypes, data, ctx));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getChildren",
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2() {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              return _context2.abrupt("return", []);

            case 1:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    })));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isLeaf", function () {
      return true;
    });

    _this.name = data.name;
    data.type = 'role';
    return _this;
  }

  _createClass(Role, [{
    key: "isEqual",
    value: function isEqual(value) {
      return (0, _lodash.get)(value, 'data.id') === (0, _lodash.get)(this, 'data.id');
    }
  }, {
    key: "deflate",
    value: function deflate() {
      var valueList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var parent = this.parent,
          type = this.type,
          name = this.name,
          data = this.data;
      if (parent) parent.deflate(valueList);
      valueList.push({
        type: type,
        name: name,
        id: data.id,
        requiresParent: true
      });
      return valueList;
    }
    /**
     * This function should account for the following scenarios:
     * 1. The role is a child of a group and identifies actual members
     * 2. The role is a child of a category and represents a classification
     * @param {*} valueMap
     */

  }, {
    key: "getValue",
    value: function () {
      var _getValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3() {
        var valueMap,
            data,
            parent,
            parentValue,
            type,
            treatAsType,
            _args3 = arguments;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                valueMap = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : {};
                data = this.data, parent = this.parent;
                valueMap.role = {
                  value: data // This Role is unbounded by a parent category or group (suspicious)

                };

                if (parent) {
                  _context3.next = 5;
                  break;
                }

                return _context3.abrupt("return", data);

              case 5:
                _context3.next = 7;
                return parent.getValue(valueMap);

              case 7:
                parentValue = _context3.sent;

                if (parentValue) {
                  _context3.next = 10;
                  break;
                }

                return _context3.abrupt("return");

              case 10:
                type = parent.type, treatAsType = parent.treatAsType; // This Role is related to a group

                if (!(type === _returnTypes.GROUP || type === _returnTypes.GROUP_LIST || treatAsType === _returnTypes.GROUP || treatAsType === _returnTypes.GROUP_LIST)) {
                  _context3.next = 13;
                  break;
                }

                return _context3.abrupt("return", (0, _lodash.isArray)(parentValue) ? parentValue.map(function (group) {
                  return _objectSpread({}, data, {
                    group: group
                  });
                }) : _objectSpread({}, data, {
                  group: parentValue
                }));

              case 13:
                if (!(type === _returnTypes.CATEGORY || type === _returnTypes.CATEGORY_LIST || treatAsType === _returnTypes.CATEGORY || treatAsType === _returnTypes.CATEGORY_LIST)) {
                  _context3.next = 19;
                  break;
                }

                if (!(0, _lodash.isArray)(parentValue)) {
                  _context3.next = 18;
                  break;
                }

                return _context3.abrupt("return", parentValue.map(function (category) {
                  return _objectSpread({}, data, {
                    group: category.group
                  });
                }));

              case 18:
                return _context3.abrupt("return", valueMap.instance && parentValue.group ? _objectSpread({}, data, {
                  group: parentValue.group
                }) : data);

              case 19:
                throw new Error("Unexpected context where Role parent is: ".concat(parentValue));

              case 20:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function getValue() {
        return _getValue.apply(this, arguments);
      };
    }()
  }]);

  return Role;
}(_context4.default);

exports.default = Role;

_defineProperty(Role, "global", true);

_defineProperty(Role, "type", 'role');

_defineProperty(Role, "treatAsType", _returnTypes.ROLE);

_defineProperty(Role, "returnTypes", [_returnTypes.ROLE, _returnTypes.TEXT, _returnTypes.USER]);

_defineProperty(Role, "matchTypes", [_returnTypes.ROLE, _returnTypes.TEXT]);

_defineProperty(Role, "preferredOperators", []);
//# sourceMappingURL=role.js.map
