"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _context2 = _interopRequireDefault(require("../context"));

var _globalCategories = _interopRequireDefault(require("../global-categories"));

var _globalConnections = _interopRequireDefault(require("../global-connections"));

var _globalGroups = _interopRequireDefault(require("../global-groups"));

var _globalForms = _interopRequireDefault(require("../global-forms"));

var _globalUsers = _interopRequireDefault(require("../global-users"));

var _textInput = _interopRequireDefault(require("../global-inputs/text-input"));

var _numericInput = _interopRequireDefault(require("../global-inputs/numeric-input"));

var _extensions = require("../../extensions");

var _returnTypes = require("../return-types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var RootContext =
/*#__PURE__*/
function (_Context) {
  _inherits(RootContext, _Context);

  _createClass(RootContext, null, [{
    key: "inflate",
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function inflate() {
        return _inflate.apply(this, arguments);
      };
    }()
  }]);

  function RootContext(parent, returnTypes, data, ctx) {
    var _this;

    _classCallCheck(this, RootContext);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(RootContext).call(this, parent, returnTypes, data, ctx));
    _this.contexts = [{
      type: _globalCategories.default
    }, {
      type: _globalConnections.default
    }, {
      type: _globalGroups.default
    }, {
      type: _globalForms.default
    }, {
      type: _globalUsers.default
    }, {
      type: _textInput.default
    }, {
      type: _numericInput.default
    }].concat(_extensions.rootContexts);
    return _this;
  }
  /**
   * Returns relevant child contexts
   * @override
   */


  _createClass(RootContext, [{
    key: "getChildren",
    value: function getChildren(filter) {
      var _this2 = this;

      var reduced = this.returnTypes === _returnTypes.ALL ? this.contexts : this.reduceByReturnType();

      if (filter) {
        var regex = new RegExp(filter, 'ig');
        reduced = reduced.filter(function (context) {
          return !context.type.displayName.search(regex);
        });
      }

      return reduced.map(function (context) {
        var Context = context.type,
            data = context.data;
        return new Context(_this2, _this2.returnTypes, data, _this2.ctx);
      });
    }
  }, {
    key: "isEqual",
    value: function isEqual(ctx) {
      return ctx && ctx.type === this.type;
    }
  }, {
    key: "deflate",
    value: function deflate() {
      var valueList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var parent = this.parent,
          type = this.type,
          name = this.name;
      if (parent) parent.deflate(valueList);
      valueList.push({
        type: type,
        name: name,
        requiresParent: false
      });
      return valueList;
    } // --- other stuff ---

  }, {
    key: "addContext",
    value: function addContext(type, data) {
      this.contexts.unshift({
        type: type,
        data: data
      });
    }
    /**
     * Return the filtered set of passed contexts
     */

  }, {
    key: "reduceByReturnType",
    value: function reduceByReturnType() {
      var _this3 = this;

      return this.contexts.filter(function (ctx) {
        var Context = ctx.type;
        return Context.returnTypes === _returnTypes.ALL || Context.returnTypes.some(function (type) {
          return _this3.returnTypes.includes(type);
        });
      });
    }
  }]);

  return RootContext;
}(_context2.default);

exports.default = RootContext;

_defineProperty(RootContext, "global", true);

_defineProperty(RootContext, "type", 'root');

_defineProperty(RootContext, "displayName", 'Data Source');

_defineProperty(RootContext, "returnTypes", _returnTypes.ALL);

_defineProperty(RootContext, "preferredOperators", []);
//# sourceMappingURL=index.js.map
