"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _field = _interopRequireDefault(require("./field"));

var _returnTypes = require("../../../data-dictionary/return-types");

var _operators = require("../../../data-dictionary/operators");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FieldOptionsTypeahead =
/*#__PURE__*/
function (_CMField) {
  _inherits(FieldOptionsTypeahead, _CMField);

  function FieldOptionsTypeahead() {
    _classCallCheck(this, FieldOptionsTypeahead);

    return _possibleConstructorReturn(this, _getPrototypeOf(FieldOptionsTypeahead).apply(this, arguments));
  }

  _createClass(FieldOptionsTypeahead, [{
    key: "getValue",
    value: function () {
      var _getValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var valueMap,
            data,
            parent,
            parentData,
            formKey,
            optionId,
            option,
            _args = arguments;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                valueMap = _args.length > 0 && _args[0] !== undefined ? _args[0] : {};
                data = this.data, parent = this.parent;

                if (!parent) {
                  _context.next = 19;
                  break;
                }

                _context.next = 5;
                return parent.getValue(valueMap);

              case 5:
                parentData = _context.sent;
                valueMap.formKey = data.formKey;
                formKey = valueMap.formKey;
                optionId = parentData.item[formKey];

                if (!optionId) {
                  _context.next = 15;
                  break;
                }

                _context.next = 12;
                return this.ctx.apis.cm.getOption(optionId);

              case 12:
                _context.t0 = _context.sent;
                _context.next = 16;
                break;

              case 15:
                _context.t0 = '';

              case 16:
                option = _context.t0;
                valueMap.field = {
                  option: option
                };
                return _context.abrupt("return", option);

              case 19:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function getValue() {
        return _getValue.apply(this, arguments);
      };
    }()
  }]);

  return FieldOptionsTypeahead;
}(_field.default);

exports.default = FieldOptionsTypeahead;

_defineProperty(FieldOptionsTypeahead, "typeLabel", 'OptionsTypeahead');

_defineProperty(FieldOptionsTypeahead, "type", 'cm-field-options-typeahead');

_defineProperty(FieldOptionsTypeahead, "treatAsType", _returnTypes.TEXT);

_defineProperty(FieldOptionsTypeahead, "returnTypes", [_returnTypes.TEXT]);

_defineProperty(FieldOptionsTypeahead, "matchTypes", [_returnTypes.TEXT]);

_defineProperty(FieldOptionsTypeahead, "preferredOperators", (0, _operators.names)(_operators.IS_NOT_EMPTY, _operators.IS_EMPTY));
//# sourceMappingURL=field-options-typeahead.js.map
