"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _field = _interopRequireDefault(require("./field"));

var _radioOption = _interopRequireDefault(require("./radio-option"));

var _returnTypes = require("../../../data-dictionary/return-types");

var _operators = require("../../../data-dictionary/operators");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FieldRadioButton =
/*#__PURE__*/
function (_CMField) {
  _inherits(FieldRadioButton, _CMField);

  function FieldRadioButton() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FieldRadioButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FieldRadioButton)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getChildren",
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var _assertThisInitialize, data, parent, schema, formKey, options, children;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _assertThisInitialize = _assertThisInitialized(_assertThisInitialized(_this)), data = _assertThisInitialize.data, parent = _assertThisInitialize.parent;
              schema = (0, _lodash.get)(parent, 'data.schema');
              formKey = (0, _lodash.get)(data, 'formKey');

              if (!(!data || !schema || !formKey)) {
                _context.next = 5;
                break;
              }

              return _context.abrupt("return", []);

            case 5:
              options = (0, _lodash.get)(schema[formKey], 'options', []);
              children = (0, _lodash.map)(options, function (optionData) {
                return new _radioOption.default(_assertThisInitialized(_assertThisInitialized(_this)), _this.returnTypes, optionData, _this.ctx);
              });
              return _context.abrupt("return", children);

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    })));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isLeaf", function () {
      return false;
    });

    return _this;
  }

  return FieldRadioButton;
}(_field.default);

exports.default = FieldRadioButton;

_defineProperty(FieldRadioButton, "typeLabel", 'Radios');

_defineProperty(FieldRadioButton, "type", 'cm-field-radio-button');

_defineProperty(FieldRadioButton, "treatAsType", _returnTypes.TEXT);

_defineProperty(FieldRadioButton, "returnTypes", [_returnTypes.NUMBER, _returnTypes.TEXT]);

_defineProperty(FieldRadioButton, "matchTypes", [_returnTypes.NUMBER, _returnTypes.TEXT]);

_defineProperty(FieldRadioButton, "preferredOperators", (0, _operators.names)(_operators.IS, _operators.IS_NOT));

_defineProperty(FieldRadioButton, "hasEnumerableValues", true);
//# sourceMappingURL=field-radio-button.js.map
