"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _context3 = _interopRequireDefault(require("../../../data-dictionary/context"));

var _returnTypes = require("../../../data-dictionary/return-types");

var _fieldTextInput = _interopRequireDefault(require("./field-text-input"));

var _fieldCoreGroupTypeahead = _interopRequireDefault(require("./field-core-group-typeahead"));

var _fieldCoreGroupMultiselect = _interopRequireDefault(require("./field-core-group-multiselect"));

var _fieldCoreUserTypeahead = _interopRequireDefault(require("./field-core-user-typeahead"));

var _fieldRadioButton = _interopRequireDefault(require("./field-radio-button"));

var _fieldCheckbox = _interopRequireDefault(require("./field-checkbox"));

var _fieldCheckboxes = _interopRequireDefault(require("./field-checkboxes"));

var _fieldTextArea = _interopRequireDefault(require("./field-text-area"));

var _fieldOptionsTypeahead = _interopRequireDefault(require("./field-options-typeahead"));

var _fieldOptionsMultiselect = _interopRequireDefault(require("./field-options-multiselect"));

var _fieldProposalType = _interopRequireDefault(require("./field-proposal-type"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var fieldList = {
  CMFieldTextInput: _fieldTextInput.default,
  CMFieldCoreGroupTypeahead: _fieldCoreGroupTypeahead.default,
  CMFieldCoreGroupMultiselect: _fieldCoreGroupMultiselect.default,
  CMFieldUserTypeahead: _fieldCoreUserTypeahead.default,
  CMFieldRadioButton: _fieldRadioButton.default,
  CMFieldCheckbox: _fieldCheckbox.default,
  CMFieldCheckboxes: _fieldCheckboxes.default,
  CMFieldTextArea: _fieldTextArea.default,
  CMFieldOptionsTypeahead: _fieldOptionsTypeahead.default,
  CMFieldOptionsMultiselect: _fieldOptionsMultiselect.default
};
var fieldMap = (0, _lodash.keyBy)(fieldList, 'typeLabel');
/**
 * Creates a Form Context
 *
 * @param {Object} parent The parent Context
 * @param {Array|String} returnTypes The array of contexts or '*' for all
 * @param {Object} data The parent Context
 */

var Form =
/*#__PURE__*/
function (_Context) {
  _inherits(Form, _Context);

  _createClass(Form, null, [{
    key: "inflate",
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(ctx, deflated) {
        var schema;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return ctx.apis.cm.schema(deflated.id);

              case 2:
                schema = _context.sent;
                return _context.abrupt("return", Object.assign({}, deflated, {
                  schema: schema
                }));

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function inflate(_x, _x2) {
        return _inflate.apply(this, arguments);
      };
    }()
  }]);

  function Form(parent, returnTypes, data, ctx) {
    var _this;

    _classCallCheck(this, Form);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Form).call(this, parent, returnTypes, data, ctx));

    _this.validate(data);

    _this.name = data.label;
    return _this;
  }

  _createClass(Form, [{
    key: "getChildren",
    value: function () {
      var _getChildren = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(search) {
        var _this2 = this;

        var schema, myReturnTypes, children, regex;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(!this.data || !this.data.id)) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt("return", []);

              case 2:
                _context2.t0 = this.data.schema;

                if (_context2.t0) {
                  _context2.next = 7;
                  break;
                }

                _context2.next = 6;
                return this.ctx.apis.cm.schema(this.data.id);

              case 6:
                _context2.t0 = _context2.sent;

              case 7:
                schema = _context2.t0;
                myReturnTypes = (0, _lodash.isArray)(this.returnTypes) ? this.returnTypes : [this.returnTypes];
                children = (0, _lodash.map)(schema, function (field, formKey) {
                  var FieldContext = formKey === 'meta.proposalType' ? _fieldProposalType.default : fieldMap[field.type];

                  if (FieldContext && (myReturnTypes.includes(_returnTypes.ALL) || FieldContext.returnTypes === _returnTypes.ALL || FieldContext.returnTypes.some(function (type) {
                    return _this2.returnTypes.includes(type);
                  }))) {
                    return new FieldContext(_this2, _this2.returnTypes, _objectSpread({
                      formKey: formKey
                    }, field), _this2.ctx);
                  }
                });

                if (search) {
                  regex = new RegExp(search, 'ig');
                  children = (0, _lodash.filter)(children, function (child) {
                    return !(0, _lodash.get)(child, 'data.label', '').search(regex);
                  });
                }

                return _context2.abrupt("return", (0, _lodash.compact)(children));

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function getChildren(_x3) {
        return _getChildren.apply(this, arguments);
      };
    }()
  }, {
    key: "matches",
    value: function matches(match) {
      if (!this.match || !match) return false;
      if (match === _returnTypes.FORM) return true;
      var thisMatch = (0, _lodash.isArray)(this.match) ? this.match : [this.match];
      var thatMatch = (0, _lodash.isArray)(match) ? match : [match];
      return thisMatch.some(function (tm) {
        return thatMatch.includes(tm);
      }) || false;
    }
  }, {
    key: "isLeaf",
    value: function isLeaf() {
      return false;
    }
  }, {
    key: "deflate",
    value: function deflate() {
      var valueList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var parent = this.parent,
          type = this.type,
          name = this.name,
          data = this.data;
      if (parent) parent.deflate(valueList);
      valueList.push({
        type: type,
        name: name,
        id: data.id,
        label: data.label,
        requiresParent: false
      });
      return valueList;
    }
  }, {
    key: "isEqual",
    value: function isEqual(ctx) {
      return (0, _lodash.get)(this, 'data.id') === (0, _lodash.get)(ctx, 'data.id');
    } // --- Utility Functions ---

  }, {
    key: "validate",
    value: function validate(data) {
      if (!data || !data.id) {
        throw new Error('Cannot create a Form Context without propperly formatted form data');
      }
    }
  }]);

  return Form;
}(_context3.default);

exports.default = Form;

_defineProperty(Form, "global", false);

_defineProperty(Form, "type", 'cmformfill');

_defineProperty(Form, "typeLabel", 'CM Form');

_defineProperty(Form, "treatAsType", _returnTypes.FORM);

_defineProperty(Form, "matchTypes", [_returnTypes.FORM]);
//# sourceMappingURL=form.js.map
