"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _context3 = _interopRequireDefault(require("../../../data-dictionary/context"));

var _form = _interopRequireDefault(require("./form"));

var _returnTypes = require("../../../data-dictionary/return-types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CMForms =
/*#__PURE__*/
function (_Context) {
  _inherits(CMForms, _Context);

  function CMForms() {
    _classCallCheck(this, CMForms);

    return _possibleConstructorReturn(this, _getPrototypeOf(CMForms).apply(this, arguments));
  }

  _createClass(CMForms, [{
    key: "getChildren",
    value: function () {
      var _getChildren = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(search) {
        var _this = this;

        var institution, settings, forms, regex, formCtxs;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (this.ctx) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return", []);

              case 2:
                _context.next = 4;
                return this.ctx.apis.cm.institution();

              case 4:
                institution = _context.sent;
                _context.next = 7;
                return this.ctx.apis.cm.settings();

              case 7:
                settings = _context.sent;
                forms = CMForms.extractFormOptionsFromSettings(institution, settings);

                if (search) {
                  regex = new RegExp(search, 'ig');
                  forms = (0, _lodash.filter)(forms, function (form) {
                    return !form.label.search(regex);
                  });
                }

                formCtxs = forms.map(function (form) {
                  return new _form.default(_this, _this.returnTypes, form, _this.ctx);
                });
                return _context.abrupt("return", formCtxs);

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function getChildren(_x) {
        return _getChildren.apply(this, arguments);
      };
    }()
  }, {
    key: "deflate",
    value: function deflate() {
      var valueList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var parent = this.parent,
          type = this.type,
          name = this.name;
      if (parent) parent.deflate(valueList);
      valueList.push({
        type: type,
        name: name,
        requiresParent: false
      });
      return valueList;
    }
  }, {
    key: "isEqual",
    value: function isEqual(ctx) {
      return this.name === (0, _lodash.get)(ctx, 'name') && this.type === (0, _lodash.get)(ctx, 'type');
    }
  }], [{
    key: "inflate",
    value: function () {
      var _inflate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(ctx, deflated) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", deflated);

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function inflate(_x2, _x3) {
        return _inflate.apply(this, arguments);
      };
    }()
  }, {
    key: "extractFormOptionsFromSettings",
    value: function extractFormOptionsFromSettings(institution, settings) {
      var formOptions = [{
        id: 'courses',
        label: (0, _lodash.get)(settings, 'uiTextReplacements.course') || 'Courses'
      }, {
        id: 'programs',
        label: (0, _lodash.get)(settings, 'uiTextReplacements.program') || 'Programs'
      }];

      if ((0, _lodash.get)(institution, 'flags.experienceItem')) {
        formOptions.push({
          id: 'experiences',
          label: (0, _lodash.get)(settings, 'uiTextReplacements.experience') || 'Experiences'
        });
      }

      if ((0, _lodash.get)(institution, 'flags.specializationItem')) {
        formOptions.push({
          id: 'specializations',
          label: (0, _lodash.get)(settings, 'uiTextReplacements.specialization') || 'Specializations'
        });
      }

      if ((0, _lodash.get)(institution, 'flags.policies')) {
        formOptions.push({
          id: 'policies',
          label: (0, _lodash.get)(settings, 'uiTextReplacements.policie') || 'Policies'
        });
      }

      return formOptions;
    }
  }]);

  return CMForms;
}(_context3.default);

exports.default = CMForms;

_defineProperty(CMForms, "global", false);

_defineProperty(CMForms, "type", 'cm-forms');

_defineProperty(CMForms, "displayName", 'CM Forms');

_defineProperty(CMForms, "returnTypes", [_returnTypes.FORM]);
//# sourceMappingURL=index.js.map
