"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getValue = getValue;
exports.apis = exports.rootContexts = exports.contexts = void 0;

var _bluebird = _interopRequireDefault(require("bluebird"));

var _cmForms = _interopRequireDefault(require("./contexts/cm-forms"));

var _form = _interopRequireDefault(require("./contexts/cm-forms/form"));

var _fieldCheckboxes = _interopRequireDefault(require("./contexts/cm-forms/field-checkboxes"));

var _fieldOptionsMultiselect = _interopRequireDefault(require("./contexts/cm-forms/field-options-multiselect"));

var _fieldOptionsTypeahead = _interopRequireDefault(require("./contexts/cm-forms/field-options-typeahead"));

var _fieldProposalType = _interopRequireDefault(require("./contexts/cm-forms/field-proposal-type"));

var _fieldTextInput = _interopRequireDefault(require("./contexts/cm-forms/field-text-input"));

var _fieldCoreGroupTypeahead = _interopRequireDefault(require("./contexts/cm-forms/field-core-group-typeahead"));

var _fieldCoreGroupMultiselect = _interopRequireDefault(require("./contexts/cm-forms/field-core-group-multiselect"));

var _fieldCoreUserTypeahead = _interopRequireDefault(require("./contexts/cm-forms/field-core-user-typeahead"));

var _fieldRadioButton = _interopRequireDefault(require("./contexts/cm-forms/field-radio-button"));

var _fieldCheckbox = _interopRequireDefault(require("./contexts/cm-forms/field-checkbox"));

var _radioOption = _interopRequireDefault(require("./contexts/cm-forms/radio-option"));

var _fieldTextArea = _interopRequireDefault(require("./contexts/cm-forms/field-text-area"));

var _cm = _interopRequireDefault(require("./api/cm"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var contexts = [_cmForms.default, _form.default, _fieldTextInput.default, _fieldCoreGroupTypeahead.default, _fieldCoreGroupMultiselect.default, _fieldCoreUserTypeahead.default, _fieldRadioButton.default, _fieldCheckbox.default, _radioOption.default, _fieldTextArea.default, _fieldCheckboxes.default, _fieldOptionsMultiselect.default, _fieldOptionsTypeahead.default, _fieldProposalType.default];
exports.contexts = contexts;
var rootContexts = [{
  type: _cmForms.default
}];
exports.rootContexts = rootContexts;
var apis = [_cm.default];
exports.apis = apis;

function getValue(_x, _x2) {
  return _getValue.apply(this, arguments);
}

function _getValue() {
  _getValue = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(wfContext, context) {
    var valueMap,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            valueMap = _args.length > 2 && _args[2] !== undefined ? _args[2] : {};
            _context.t0 = context.type;
            _context.next = _context.t0 === 'cmformfill' ? 4 : 5;
            break;

          case 4:
            return _context.abrupt("return", getCMFormfillValue(wfContext, context, valueMap));

          case 5:
            return _context.abrupt("return", false);

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _getValue.apply(this, arguments);
}

function getCMFormfillValue(_x3, _x4, _x5) {
  return _getCMFormfillValue.apply(this, arguments);
}

function _getCMFormfillValue() {
  _getCMFormfillValue = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(wfContext, formContext, valueMap) {
    var definition, instance, instances, formId, _wfContext$findDefini, definitionStep, instanceStep, responses;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            definition = valueMap.definition, instance = valueMap.instance, instances = valueMap.instances;
            formId = formContext.data.id;
            _wfContext$findDefini = wfContext.findDefinitionStep(formId, definition), definitionStep = _wfContext$findDefini.step;
            instanceStep = wfContext.findInstanceStep(definitionStep._id.toString(), instance, instances);
            _context2.next = 6;
            return _bluebird.default.props({
              schema: wfContext.ctx.apis.cm.schema(formId),
              item: wfContext.ctx.apis.cm.getItem(formId, instanceStep.meta.form.itemId)
            });

          case 6:
            responses = _context2.sent;
            return _context2.abrupt("return", _objectSpread({}, responses, {
              definitionStep: definitionStep,
              instanceStep: instanceStep
            }));

          case 8:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));
  return _getCMFormfillValue.apply(this, arguments);
}
//# sourceMappingURL=index.js.map
