"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.LOGICAL_OPERATORS = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _index = require("../data-dictionary/operators/index");

var _LOGICAL_OPERATOR_EVA;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var LOGICAL_OPERATORS = {
  AND: 'and',
  OR: 'or'
};
exports.LOGICAL_OPERATORS = LOGICAL_OPERATORS;

var expressionIsTrue = function expressionIsTrue(evaluatedExpression) {
  return evaluatedExpression === true;
};

var logicalOperator = _lodash.default.curry(function (logicalIterator, comparator, evaluatedExpressions) {
  return logicalIterator(evaluatedExpressions, comparator);
});

var LOGICAL_OPERATOR_EVALUATORS = (_LOGICAL_OPERATOR_EVA = {}, _defineProperty(_LOGICAL_OPERATOR_EVA, LOGICAL_OPERATORS.AND, logicalOperator(_lodash.default.every, expressionIsTrue)), _defineProperty(_LOGICAL_OPERATOR_EVA, LOGICAL_OPERATORS.OR, logicalOperator(_lodash.default.some, expressionIsTrue)), _LOGICAL_OPERATOR_EVA);

var CompoundRule =
/*#__PURE__*/
function () {
  function CompoundRule(rule, resolver) {
    var ruleEvaluator = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _index.evaluate;

    _classCallCheck(this, CompoundRule);

    this.rule = rule;
    this.resolver = resolver;
    this.ruleEvaluator = ruleEvaluator;
  }

  _createClass(CompoundRule, [{
    key: "evaluate",
    value: function () {
      var _evaluate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(Rule) {
        var _this = this;

        var _this$rule, logicalOperator, expressions, promises, evaluatedExpressions, operatorFn;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$rule = this.rule, logicalOperator = _this$rule.logicalOperator, expressions = _this$rule.expressions;

                if (_lodash.default.has(LOGICAL_OPERATORS, _lodash.default.toUpper(logicalOperator))) {
                  _context.next = 3;
                  break;
                }

                throw new Error("Unknown logical operator \"".concat(logicalOperator, "\""));

              case 3:
                promises = expressions.map(function (expression) {
                  var rule = new Rule(expression, _this.resolver);
                  return rule.evaluate();
                });
                _context.next = 6;
                return Promise.all(promises);

              case 6:
                evaluatedExpressions = _context.sent;
                operatorFn = LOGICAL_OPERATOR_EVALUATORS[logicalOperator];
                return _context.abrupt("return", operatorFn(evaluatedExpressions));

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function evaluate(_x) {
        return _evaluate.apply(this, arguments);
      };
    }()
  }, {
    key: "toJSON",
    value: function toJSON(Rule) {
      var _this$rule2 = this.rule,
          logicalOperator = _this$rule2.logicalOperator,
          expressions = _this$rule2.expressions;
      return {
        logicalOperator: logicalOperator,
        expressions: expressions.map(function (expression) {
          return new Rule(expression).toJSON();
        })
      };
    }
  }]);

  return CompoundRule;
}();

exports.default = CompoundRule;
//# sourceMappingURL=compound-rule.js.map
