"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _compoundRule = _interopRequireWildcard(require("./compound-rule"));

var _singularRule = _interopRequireDefault(require("./singular-rule"));

var _index = require("../data-dictionary/operators/index");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var i18n = {
  APPROPRIATE_PARAMETERS: 'Cannot construct rule without appropriate parameters'
};

var Rule =
/*#__PURE__*/
function () {
  function Rule(ruleData, resolver) {
    var ruleEvaluator = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _index.evaluate;

    _classCallCheck(this, Rule);

    this.type = this.identifyType(ruleData);
    this.rule = this.getRule(ruleData, resolver, ruleEvaluator);
  }

  _createClass(Rule, [{
    key: "getRule",
    value: function getRule(ruleData, resolver, ruleEvaluator) {
      return this.type === this.constructor.TYPES.SINGLE ? new _singularRule.default(ruleData, resolver, ruleEvaluator) : new _compoundRule.default(ruleData, resolver, ruleEvaluator);
    }
  }, {
    key: "identifyType",
    value: function identifyType(ruleData) {
      if (!ruleData) {
        throw new Error(i18n.APPROPRIATE_PARAMETERS);
      }

      var TYPES = this.constructor.TYPES;
      var left = ruleData.left,
          operator = ruleData.operator,
          logicalOperator = ruleData.logicalOperator,
          expressions = ruleData.expressions;

      if (left && operator) {
        return TYPES.SINGLE;
      } else if (logicalOperator && expressions) {
        return TYPES.COMPOUND;
      } else {
        throw new Error(i18n.APPROPRIATE_PARAMETERS);
      }
    }
  }, {
    key: "evaluate",
    value: function evaluate() {
      return this.rule.evaluate(Rule);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return this.rule.toJSON(Rule);
    }
  }]);

  return Rule;
}();

exports.default = Rule;

_defineProperty(Rule, "TYPES", {
  SINGLE: 'single',
  COMPOUND: 'compound'
});

_defineProperty(Rule, "LOGICAL_OPERATORS", _compoundRule.LOGICAL_OPERATORS);
//# sourceMappingURL=rule.js.map
