"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _contextUtils = _interopRequireDefault(require("../data-dictionary/context-utils"));

var _dataTypes = _interopRequireDefault(require("../data-dictionary/data-types"));

var _operators = require("../data-dictionary/operators");

var _index = require("../data-dictionary/operators/index");

var _coerce = require("../data-dictionary/coerce");

var _util = _interopRequireDefault(require("util"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var SingularRule =
/*#__PURE__*/
function () {
  function SingularRule(rule, resolver) {
    var ruleEvaluator = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _index.evaluate;

    _classCallCheck(this, SingularRule);

    this.rule = rule;
    this.resolver = resolver;
    this.structuredOperator = (0, _operators.getOperator)(this.rule.operator);
    this.ruleEvaluator = ruleEvaluator;
  }

  _createClass(SingularRule, [{
    key: "compareAsIs",
    value: function compareAsIs(left, right) {
      return this.ruleEvaluator(this.structuredOperator, _lodash.default.get(left, ['context', 'treatAsType']), _lodash.default.get(left, 'value'), _lodash.default.get(right, ['context', 'treatAsType']), _lodash.default.get(right, 'value'));
    }
  }, {
    key: "coerceAndCompare",
    value: function coerceAndCompare(left, right) {
      var comparable = this.findComparableTypes(left, this.structuredOperator, right);
      var response = this.findBestResponse(comparable, left, this.structuredOperator, right);
      return response;
    }
  }, {
    key: "evaluate",
    value: function () {
      var _evaluate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(_Rule) {
        var promises, _ref, _ref2, left, right;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                promises = [this.resolver(this.rule.left)];

                if (this.rule.right) {
                  promises.push(this.resolver(this.rule.right));
                }

                _context.next = 5;
                return Promise.all(promises);

              case 5:
                _ref = _context.sent;
                _ref2 = _slicedToArray(_ref, 2);
                left = _ref2[0];
                right = _ref2[1];

                if (!(0, _index.isOperationSupported)(this.structuredOperator, _lodash.default.get(left, ['context', 'treatAsType']), _lodash.default.get(right, ['context', 'treatAsType']))) {
                  _context.next = 11;
                  break;
                }

                return _context.abrupt("return", this.compareAsIs(left, right));

              case 11:
                return _context.abrupt("return", this.coerceAndCompare(left, right));

              case 14:
                _context.prev = 14;
                _context.t0 = _context["catch"](0);
                console.log('Error evaluating...');
                console.log('rule ->', JSON.stringify(this.rule, null, 2));
                console.log(_context.t0);
                throw _context.t0;

              case 20:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 14]]);
      }));

      return function evaluate(_x) {
        return _evaluate.apply(this, arguments);
      };
    }()
  }, {
    key: "findComparableTypes",
    value: function findComparableTypes(left, operator, right) {
      try {
        return _lodash.default.flatMapDeep(left.types, function (leftTypeName) {
          // TODO what if we don't get a leftType here?
          var leftType = _lodash.default.get(_dataTypes.default, leftTypeName, {});

          if ((0, _operators.isUnary)(operator)) {
            return {
              left: leftType
            };
          } // TODO what if left type doesn't have support for this operator?


          var operatorSupportedRightTypes = (0, _index.supportedRightTypes)(operator, leftTypeName);

          var rightValueSupportedTypes = _lodash.default.get(right, 'types', []);

          var intersectingRightTypes = _lodash.default.intersection(operatorSupportedRightTypes, rightValueSupportedTypes);

          return _lodash.default.map(intersectingRightTypes, function (rightTypeName) {
            return {
              left: leftType,
              right: _lodash.default.get(_dataTypes.default, rightTypeName, {}) // TODO what if we don't get a rightType here?

            };
          });
        });
      } catch (err) {
        console.log('Error finding comparable types.');
        console.log('left ->');
        console.log(_util.default.inspect(left, {
          depth: 5
        }));
        console.log('operator ->');
        console.log(operator);
        console.log('right ->');
        console.log(_util.default.inspect(right, {
          depth: 5
        }));
      }
    }
  }, {
    key: "findBestResponse",
    value: function findBestResponse(comparables, left, operator, right) {
      for (var i = 0; i < comparables.length; i++) {
        try {
          var comparable = comparables[i];

          var leftTargetType = _lodash.default.get(comparable, 'left.TYPE');

          var rightTargetType = _lodash.default.get(comparable, 'right.TYPE');

          var coercedLeft = (0, _coerce.coerce)(_lodash.default.get(left, ['context', 'treatAsType']), leftTargetType, _lodash.default.get(left, 'value'));
          var coercedRight = right ? (0, _coerce.coerce)(_lodash.default.get(right, ['context', 'treatAsType']), rightTargetType, _lodash.default.get(right, 'value')) : undefined;
          return this.ruleEvaluator(operator, leftTargetType, coercedLeft, rightTargetType, coercedRight);
        } catch (error) {
          console.log("[".concat(operator, "] Operation Failed:"), error);
          var isLastComparable = comparables.length === i + 1;

          if (isLastComparable) {
            throw error;
          }
        }
      }
    }
  }, {
    key: "toJSON",
    value: function toJSON(_Rule) {
      var _this$rule = this.rule,
          left = _this$rule.left,
          operator = _this$rule.operator,
          right = _this$rule.right;
      return {
        left: _contextUtils.default.deflate(left),
        operator: operator,
        right: _contextUtils.default.deflate(right)
      };
    }
  }]);

  return SingularRule;
}();

exports.default = SingularRule;
//# sourceMappingURL=singular-rule.js.map
