"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _index = _interopRequireDefault(require("../../index"));

var _contextUtils = _interopRequireDefault(require("../../../data-dictionary/context-utils"));

var _context = _interopRequireDefault(require("../../../data-dictionary/context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var i18n = {
  MISSING_FORM: 'Unable to create an Approval step without a form',
  MISSING_APPROVER: 'Unable to create an Approval step without an approver',
  MISSING_VOTING: 'Unable to create an Approval step without voting rules'
  /**
   * Creates a FormApprovalModel
   * requires the following params:
   * data = {
   *   name: [optional] string,
   *   form: context,
   *   approver: context,
   *   voting: object
   * }
   */

};

var FormApprovalModel =
/*#__PURE__*/
function (_StepModel) {
  _inherits(FormApprovalModel, _StepModel);

  function FormApprovalModel(data) {
    var _this;

    _classCallCheck(this, FormApprovalModel);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FormApprovalModel).call(this, data));
    _this.meta = {};

    if (data) {
      var form = data.form,
          approver = data.approver,
          voting = data.voting;
      Object.assign(_this.meta, {
        form: form,
        approver: approver,
        voting: voting
      });
    }

    return _this;
  }

  _createClass(FormApprovalModel, [{
    key: "validate",
    value: function validate() {
      var _this$meta = this.meta,
          form = _this$meta.form,
          approver = _this$meta.approver,
          voting = _this$meta.voting;
      if (!form || !(form instanceof _context.default)) throw new Error(i18n.MISSING_FORM);

      if (!approver || !(approver instanceof _context.default)) {
        throw new Error(i18n.MISSING_APPROVER);
      }

      if (!voting) throw new Error(i18n.MISSING_VOTING);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var persistable = (0, _lodash.pick)(this, ['_id', 'name', 'type']);
      var _this$meta2 = this.meta,
          form = _this$meta2.form,
          approver = _this$meta2.approver,
          voting = _this$meta2.voting;
      persistable.meta = {
        form: _contextUtils.default.deflate(form),
        approver: _contextUtils.default.deflate(approver),
        voting: voting
      };
      return persistable;
    }
  }]);

  return FormApprovalModel;
}(_index.default);

exports.default = FormApprovalModel;

_defineProperty(FormApprovalModel, "displayName", 'Approval');

_defineProperty(FormApprovalModel, "type", 'form-approval');
//# sourceMappingURL=index.js.map
