"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _index = _interopRequireDefault(require("../../index"));

var _rule = _interopRequireDefault(require("../../../rules/rule"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var i18n = {
  MISSING_CONDITIONS: 'Unable to create a Conditional step without routes'
  /**
   * Creates a ConditionalModel
   * requires the following params:
   * data = {
   *   _id: [optional <string>],
   *   name: [optional <string>],
   *   routes: [
   *     {
   *       name: [optional <string>],
   *       rule: [required <rule>],
   *       flow: [optional <workflow._id>]
   *     }
   *   ]
   * }
   */

};

var ConditionalModel =
/*#__PURE__*/
function (_StepModel) {
  _inherits(ConditionalModel, _StepModel);

  function ConditionalModel(data) {
    var _this;

    _classCallCheck(this, ConditionalModel);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ConditionalModel).call(this, data));

    if (!data || !data.routes) {
      throw new Error(i18n.MISSING_CONDITIONS);
    }

    var routes = data.routes.map(function (_ref) {
      var name = _ref.name,
          flow = _ref.flow,
          rule = _ref.rule;
      return !rule || rule instanceof _rule.default ? {
        name: name,
        flow: flow,
        rule: rule
      } : {
        name: name,
        flow: flow,
        rule: new _rule.default(rule)
      };
    });
    _this.meta = {
      routes: routes
    };
    return _this;
  }

  _createClass(ConditionalModel, [{
    key: "createMissingFlows",
    value: function () {
      var _createMissingFlows = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(flowAPI) {
        var _this2 = this;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return Promise.all(this.meta.routes.map(function (route, index) {
                  return route.flow ? Promise.resolve(route) : _this2.addFlowToRoute(route, index, flowAPI);
                }));

              case 2:
                this.meta.routes = _context.sent;

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function createMissingFlows(_x) {
        return _createMissingFlows.apply(this, arguments);
      };
    }()
  }, {
    key: "addFlowToRoute",
    value: function () {
      var _addFlowToRoute = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(route, index, flowAPI) {
        var flow;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return flowAPI.create({
                  name: route.name || "Route ".concat(index, " Flow"),
                  hidden: true
                });

              case 2:
                flow = _context2.sent;
                route.flow = flow._id;
                return _context2.abrupt("return", route);

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function addFlowToRoute(_x2, _x3, _x4) {
        return _addFlowToRoute.apply(this, arguments);
      };
    }()
  }, {
    key: "validate",
    value: function validate() {
      return true;
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var persistable = (0, _lodash.pick)(this, ['_id', 'name', 'type']);
      var routes = this.meta.routes.map(function (r, index) {
        var pr = {
          name: r.name === undefined ? "Route ".concat(index) : r.name,
          flow: r.flow === undefined ? "new-".concat(index, ".").concat(Date.now()) : r.flow,
          rule: r.rule ? r.rule.toJSON() : undefined
        };
        return pr;
      });
      persistable.meta = {
        routes: routes
      };
      return persistable;
    }
  }]);

  return ConditionalModel;
}(_index.default);

exports.default = ConditionalModel;

_defineProperty(ConditionalModel, "displayName", 'Branch');

_defineProperty(ConditionalModel, "type", 'conditional');
//# sourceMappingURL=index.js.map
