"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _index = _interopRequireDefault(require("../index"));

var _contextUtils = _interopRequireDefault(require("../../data-dictionary/context-utils"));

var _context = _interopRequireDefault(require("../../data-dictionary/context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var i18n = {
  MISSING_CONNECTION: 'Unable to create an Integration model without a connection'
  /**
   * Creates an IntegrationModel
   * requires the following params:
   * data = {
   *   name: [optional] string,
   *   connection: context,
   *   dataSource: context (inflated or deflated)
   * }
   *
   * This is the format of the app-connection-api
   * --------------------------------------------
   * id: "5baa65b2bca734001b08213a",
   * deleted: false,
   * status: "draft",
   * formContainerId: "5baa5efcbca734001b082133",
   * data = {
   *   __connectionName: string,
   *   __description: [optional] string,
   *   __method: string (options: 'get', 'post'),
   *   __connectionUrl: string,
   *   __authenticationType: string,
   *   __apiKeyHeader: string,
   *   __apiKey: string
   * },
   * formId: "5baa5efcbca734001b082138",
   * createdAt: "2018-09-25T16:43:30.976Z",
   * updatedAt: "2018-09-25T16:43:30.976Z"
   */

};

var IntegrationModel =
/*#__PURE__*/
function (_StepModel) {
  _inherits(IntegrationModel, _StepModel);

  function IntegrationModel(data) {
    var _this;

    _classCallCheck(this, IntegrationModel);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(IntegrationModel).call(this, data));
    _this.meta = {};

    if (data) {
      _this.meta.connection = data.connection;
      _this.meta.dataSource = data.dataSource;
    }

    return _this;
  }

  _createClass(IntegrationModel, [{
    key: "validate",
    value: function validate() {
      var connection = this.meta.connection;

      if (!connection || !(connection instanceof _context.default)) {
        throw new Error(i18n.MISSING_CONNECTION);
      }
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var persistable = (0, _lodash.pick)(this, ['_id', 'name', 'type']);
      var _this$meta = this.meta,
          connection = _this$meta.connection,
          dataSource = _this$meta.dataSource;
      persistable.meta = {
        connection: _contextUtils.default.deflate(connection)
      };

      if (dataSource) {
        if (dataSource instanceof _context.default) {
          persistable.meta.dataSource = _contextUtils.default.deflate(dataSource);
        } else if ((0, _lodash.isArray)(dataSource) && dataSource[0].type === 'root') {
          persistable.meta.dataSource = dataSource;
        }
      }

      return persistable;
    }
  }]);

  return IntegrationModel;
}(_index.default);

exports.default = IntegrationModel;

_defineProperty(IntegrationModel, "name", 'Integration');

_defineProperty(IntegrationModel, "type", 'integration');
//# sourceMappingURL=index.js.map
