"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _index = _interopRequireDefault(require("../../index"));

var _contextUtils = _interopRequireDefault(require("../../../data-dictionary/context-utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var i18n = {
  INVALID_FORMAT: 'Notification Step data has an invalid format',
  MISSING_RECIPIENT: 'Notification Steps require a recipient',
  MISSING_SUBJECT: 'Notification Steps require a subject',
  MISSING_SOURCES: 'Notification Steps require sources'
  /**
   * Creates a notification step
   * requires the following params:
   * {
   *   recipient: <context>,
   *   type: 'email',
   *   subject: '',
   *   body: '',
   *   sources: {
   *     key1: <context>,
   *     key2: <context>
   *   }
   * }
   */

};

var NotificationModel =
/*#__PURE__*/
function (_StepModel) {
  _inherits(NotificationModel, _StepModel);

  function NotificationModel(data) {
    var _this;

    _classCallCheck(this, NotificationModel);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(NotificationModel).call(this, data));
    var recipient = data.recipient,
        _data$type = data.type,
        type = _data$type === void 0 ? 'email' : _data$type,
        subject = data.subject,
        body = data.body,
        _data$sources = data.sources,
        sources = _data$sources === void 0 ? {} : _data$sources;
    _this.meta = {
      type: type,
      recipient: recipient,
      subject: subject,
      body: body,
      sources: sources
    };
    return _this;
  }

  _createClass(NotificationModel, [{
    key: "validate",
    value: function validate() {
      if (!this.meta) throw new Error(i18n.INVALID_FORMAT);
      var _this$meta = this.meta,
          recipient = _this$meta.recipient,
          subject = _this$meta.subject,
          sources = _this$meta.sources;
      if (!recipient) throw new Error(i18n.MISSING_RECIPIENT);
      if (!subject) throw new Error(i18n.MISSING_SUBJECT);
      if (!sources) throw new Error(i18n.MISSING_SOURCES);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var persistable = (0, _lodash.pick)(this, ['_id', 'name', 'type']);

      var recipient = _contextUtils.default.deflate(this.meta.recipient);

      var sources = (0, _lodash.mapValues)(this.meta.sources, function (src) {
        return _contextUtils.default.deflate(src);
      });
      persistable.meta = _objectSpread({}, this.meta, {
        recipient: recipient,
        sources: sources
      });
      return persistable;
    }
  }]);

  return NotificationModel;
}(_index.default);

exports.default = NotificationModel;

_defineProperty(NotificationModel, "displayName", 'Notification');

_defineProperty(NotificationModel, "type", 'notification');
//# sourceMappingURL=index.js.map
