"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

var _index = _interopRequireDefault(require("../../index"));

var _contextUtils = _interopRequireDefault(require("../../../data-dictionary/context-utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var i18n = {
  INVALID_FORMAT: 'Log Step data has an invalid format',
  MISSING_TEMPLATE: 'Log Steps require a template',
  MISSING_VARIABLES: 'Log Steps require variables'
  /**
   * Creates a log step
   * requires the following params:
   * {
   *   template: 'Took path: {{key}}',
   *   variables: {
   *     key: <context>
   *   }
   * }
   */

};

var LogModel =
/*#__PURE__*/
function (_StepModel) {
  _inherits(LogModel, _StepModel);

  function LogModel(data) {
    var _this;

    _classCallCheck(this, LogModel);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LogModel).call(this, data));
    _this.meta = {
      template: data.template,
      variables: data.variables || {}
    };
    return _this;
  }

  _createClass(LogModel, [{
    key: "validate",
    value: function validate() {
      if (!this.meta) throw new Error(i18n.INVALID_FORMAT);
      var _this$meta = this.meta,
          template = _this$meta.template,
          variables = _this$meta.variables;
      if (!template) throw new Error(i18n.MISSING_TEMPLATE);
      if (!variables) throw new Error(i18n.MISSING_VARIABLES);
    }
    /**
     * Returns the following format
     * {
     *   _id,
     *   name,
     *   type,
     *   meta: {
     *     template: 'Took path: {{key}}',
     *     variables: {
     *       key: <context>
     *     }
     *   }
     * }
     */

  }, {
    key: "toJSON",
    value: function toJSON() {
      var persistable = (0, _lodash.pick)(this, ['_id', 'name', 'type']);
      var variables = (0, _lodash.mapValues)(this.meta.variables, function (v) {
        return _contextUtils.default.deflate(v);
      });
      persistable.meta = _objectSpread({}, this.meta, {
        variables: variables
      });
      return persistable;
    }
  }]);

  return LogModel;
}(_index.default);

exports.default = LogModel;

_defineProperty(LogModel, "displayName", 'Log');

_defineProperty(LogModel, "type", 'log');
//# sourceMappingURL=index.js.map
